# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class AccountDashboardStatisticRevenue(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'total': 'float',
        'influenced': 'float',
        'datetime': 'datetime'
    }

    attribute_map = {
        'total': 'total',
        'influenced': 'influenced',
        'datetime': 'datetime'
    }

    def __init__(self, total=None, influenced=None, datetime=None, local_vars_configuration=None):  # noqa: E501
        """AccountDashboardStatisticRevenue - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._total = None
        self._influenced = None
        self._datetime = None
        self.discriminator = None

        self.total = total
        self.influenced = influenced
        self.datetime = datetime

    @property
    def total(self):
        """Gets the total of this AccountDashboardStatisticRevenue.  # noqa: E501

        All revenue that went through the client's shop (including purchases that didn’t trigger an effect).  # noqa: E501

        :return: The total of this AccountDashboardStatisticRevenue.  # noqa: E501
        :rtype: float
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this AccountDashboardStatisticRevenue.

        All revenue that went through the client's shop (including purchases that didn’t trigger an effect).  # noqa: E501

        :param total: The total of this AccountDashboardStatisticRevenue.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and total is None:  # noqa: E501
            raise ValueError("Invalid value for `total`, must not be `None`")  # noqa: E501

        self._total = total

    @property
    def influenced(self):
        """Gets the influenced of this AccountDashboardStatisticRevenue.  # noqa: E501

        The revenue that was created by a purchase that triggered an effect (excluding web hooks, notifications).  # noqa: E501

        :return: The influenced of this AccountDashboardStatisticRevenue.  # noqa: E501
        :rtype: float
        """
        return self._influenced

    @influenced.setter
    def influenced(self, influenced):
        """Sets the influenced of this AccountDashboardStatisticRevenue.

        The revenue that was created by a purchase that triggered an effect (excluding web hooks, notifications).  # noqa: E501

        :param influenced: The influenced of this AccountDashboardStatisticRevenue.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and influenced is None:  # noqa: E501
            raise ValueError("Invalid value for `influenced`, must not be `None`")  # noqa: E501

        self._influenced = influenced

    @property
    def datetime(self):
        """Gets the datetime of this AccountDashboardStatisticRevenue.  # noqa: E501

        Values aggregated for the specified date.  # noqa: E501

        :return: The datetime of this AccountDashboardStatisticRevenue.  # noqa: E501
        :rtype: datetime
        """
        return self._datetime

    @datetime.setter
    def datetime(self, datetime):
        """Sets the datetime of this AccountDashboardStatisticRevenue.

        Values aggregated for the specified date.  # noqa: E501

        :param datetime: The datetime of this AccountDashboardStatisticRevenue.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and datetime is None:  # noqa: E501
            raise ValueError("Invalid value for `datetime`, must not be `None`")  # noqa: E501

        self._datetime = datetime

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AccountDashboardStatisticRevenue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AccountDashboardStatisticRevenue):
            return True

        return self.to_dict() != other.to_dict()
