# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class AddLoyaltyPoints(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'points': 'float',
        'name': 'str',
        'validity_duration': 'str',
        'valid_until': 'datetime',
        'pending_duration': 'str',
        'pending_until': 'datetime',
        'subledger_id': 'str',
        'application_id': 'int'
    }

    attribute_map = {
        'points': 'points',
        'name': 'name',
        'validity_duration': 'validityDuration',
        'valid_until': 'validUntil',
        'pending_duration': 'pendingDuration',
        'pending_until': 'pendingUntil',
        'subledger_id': 'subledgerId',
        'application_id': 'applicationId'
    }

    def __init__(self, points=None, name=None, validity_duration=None, valid_until=None, pending_duration=None, pending_until=None, subledger_id=None, application_id=None, local_vars_configuration=None):  # noqa: E501
        """AddLoyaltyPoints - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._points = None
        self._name = None
        self._validity_duration = None
        self._valid_until = None
        self._pending_duration = None
        self._pending_until = None
        self._subledger_id = None
        self._application_id = None
        self.discriminator = None

        self.points = points
        if name is not None:
            self.name = name
        if validity_duration is not None:
            self.validity_duration = validity_duration
        if valid_until is not None:
            self.valid_until = valid_until
        if pending_duration is not None:
            self.pending_duration = pending_duration
        if pending_until is not None:
            self.pending_until = pending_until
        if subledger_id is not None:
            self.subledger_id = subledger_id
        if application_id is not None:
            self.application_id = application_id

    @property
    def points(self):
        """Gets the points of this AddLoyaltyPoints.  # noqa: E501

        Amount of loyalty points.  # noqa: E501

        :return: The points of this AddLoyaltyPoints.  # noqa: E501
        :rtype: float
        """
        return self._points

    @points.setter
    def points(self, points):
        """Sets the points of this AddLoyaltyPoints.

        Amount of loyalty points.  # noqa: E501

        :param points: The points of this AddLoyaltyPoints.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and points is None:  # noqa: E501
            raise ValueError("Invalid value for `points`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                points is not None and points > 999999999999.99):  # noqa: E501
            raise ValueError("Invalid value for `points`, must be a value less than or equal to `999999999999.99`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                points is not None and points <= 0):  # noqa: E501
            raise ValueError("Invalid value for `points`, must be a value greater than `0`")  # noqa: E501

        self._points = points

    @property
    def name(self):
        """Gets the name of this AddLoyaltyPoints.  # noqa: E501

        Name / reason for the point addition.  # noqa: E501

        :return: The name of this AddLoyaltyPoints.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AddLoyaltyPoints.

        Name / reason for the point addition.  # noqa: E501

        :param name: The name of this AddLoyaltyPoints.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def validity_duration(self):
        """Gets the validity_duration of this AddLoyaltyPoints.  # noqa: E501

        The time format is either: - `immediate` or, - an **integer** followed by one letter indicating the time unit.  Examples: `immediate`, `30s`, `40m`, `1h`, `5D`, `7W`, `10M`, `15Y`.  Available units:  - `s`: seconds - `m`: minutes - `h`: hours - `D`: days - `W`: weeks - `M`: months - `Y`: years  You can round certain units up or down: - `_D` for rounding down days only. Signifies the start of the day. - `_U` for rounding up days, weeks, months and years. Signifies the end of the day, week, month or year.  If passed, `validUntil` should be omitted.   # noqa: E501

        :return: The validity_duration of this AddLoyaltyPoints.  # noqa: E501
        :rtype: str
        """
        return self._validity_duration

    @validity_duration.setter
    def validity_duration(self, validity_duration):
        """Sets the validity_duration of this AddLoyaltyPoints.

        The time format is either: - `immediate` or, - an **integer** followed by one letter indicating the time unit.  Examples: `immediate`, `30s`, `40m`, `1h`, `5D`, `7W`, `10M`, `15Y`.  Available units:  - `s`: seconds - `m`: minutes - `h`: hours - `D`: days - `W`: weeks - `M`: months - `Y`: years  You can round certain units up or down: - `_D` for rounding down days only. Signifies the start of the day. - `_U` for rounding up days, weeks, months and years. Signifies the end of the day, week, month or year.  If passed, `validUntil` should be omitted.   # noqa: E501

        :param validity_duration: The validity_duration of this AddLoyaltyPoints.  # noqa: E501
        :type: str
        """

        self._validity_duration = validity_duration

    @property
    def valid_until(self):
        """Gets the valid_until of this AddLoyaltyPoints.  # noqa: E501

        Date and time when points should expire. The value should be provided in RFC 3339 format. If passed, `validityDuration` should be omitted.   # noqa: E501

        :return: The valid_until of this AddLoyaltyPoints.  # noqa: E501
        :rtype: datetime
        """
        return self._valid_until

    @valid_until.setter
    def valid_until(self, valid_until):
        """Sets the valid_until of this AddLoyaltyPoints.

        Date and time when points should expire. The value should be provided in RFC 3339 format. If passed, `validityDuration` should be omitted.   # noqa: E501

        :param valid_until: The valid_until of this AddLoyaltyPoints.  # noqa: E501
        :type: datetime
        """

        self._valid_until = valid_until

    @property
    def pending_duration(self):
        """Gets the pending_duration of this AddLoyaltyPoints.  # noqa: E501

        The amount of time before the points are considered valid.  The time format is either: - `immediate` or, - an **integer** followed by one letter indicating the time unit.  Examples: `immediate`, `30s`, `40m`, `1h`, `5D`, `7W`, `10M`, `15Y`.  Available units:  - `s`: seconds - `m`: minutes - `h`: hours - `D`: days - `W`: weeks - `M`: months - `Y`: years  You can round certain units up or down: - `_D` for rounding down days only. Signifies the start of the day. - `_U` for rounding up days, weeks, months and years. Signifies the end of the day, week, month or year.   # noqa: E501

        :return: The pending_duration of this AddLoyaltyPoints.  # noqa: E501
        :rtype: str
        """
        return self._pending_duration

    @pending_duration.setter
    def pending_duration(self, pending_duration):
        """Sets the pending_duration of this AddLoyaltyPoints.

        The amount of time before the points are considered valid.  The time format is either: - `immediate` or, - an **integer** followed by one letter indicating the time unit.  Examples: `immediate`, `30s`, `40m`, `1h`, `5D`, `7W`, `10M`, `15Y`.  Available units:  - `s`: seconds - `m`: minutes - `h`: hours - `D`: days - `W`: weeks - `M`: months - `Y`: years  You can round certain units up or down: - `_D` for rounding down days only. Signifies the start of the day. - `_U` for rounding up days, weeks, months and years. Signifies the end of the day, week, month or year.   # noqa: E501

        :param pending_duration: The pending_duration of this AddLoyaltyPoints.  # noqa: E501
        :type: str
        """

        self._pending_duration = pending_duration

    @property
    def pending_until(self):
        """Gets the pending_until of this AddLoyaltyPoints.  # noqa: E501

        Date and time after the points are considered valid. The value should be provided in RFC 3339 format. If passed, `pendingDuration` should be omitted.   # noqa: E501

        :return: The pending_until of this AddLoyaltyPoints.  # noqa: E501
        :rtype: datetime
        """
        return self._pending_until

    @pending_until.setter
    def pending_until(self, pending_until):
        """Sets the pending_until of this AddLoyaltyPoints.

        Date and time after the points are considered valid. The value should be provided in RFC 3339 format. If passed, `pendingDuration` should be omitted.   # noqa: E501

        :param pending_until: The pending_until of this AddLoyaltyPoints.  # noqa: E501
        :type: datetime
        """

        self._pending_until = pending_until

    @property
    def subledger_id(self):
        """Gets the subledger_id of this AddLoyaltyPoints.  # noqa: E501

        ID of the subledger the points are added to. If there is no existing subledger with this ID, the subledger is created automatically.  # noqa: E501

        :return: The subledger_id of this AddLoyaltyPoints.  # noqa: E501
        :rtype: str
        """
        return self._subledger_id

    @subledger_id.setter
    def subledger_id(self, subledger_id):
        """Sets the subledger_id of this AddLoyaltyPoints.

        ID of the subledger the points are added to. If there is no existing subledger with this ID, the subledger is created automatically.  # noqa: E501

        :param subledger_id: The subledger_id of this AddLoyaltyPoints.  # noqa: E501
        :type: str
        """

        self._subledger_id = subledger_id

    @property
    def application_id(self):
        """Gets the application_id of this AddLoyaltyPoints.  # noqa: E501

        ID of the Application that is connected to the loyalty program. It is displayed in your Talon.One deployment URL.  # noqa: E501

        :return: The application_id of this AddLoyaltyPoints.  # noqa: E501
        :rtype: int
        """
        return self._application_id

    @application_id.setter
    def application_id(self, application_id):
        """Sets the application_id of this AddLoyaltyPoints.

        ID of the Application that is connected to the loyalty program. It is displayed in your Talon.One deployment URL.  # noqa: E501

        :param application_id: The application_id of this AddLoyaltyPoints.  # noqa: E501
        :type: int
        """

        self._application_id = application_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AddLoyaltyPoints):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AddLoyaltyPoints):
            return True

        return self.to_dict() != other.to_dict()
