# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class AnalyticsProductSKU(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'sku': 'str',
        'last_updated': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'sku': 'sku',
        'last_updated': 'lastUpdated'
    }

    def __init__(self, id=None, sku=None, last_updated=None, local_vars_configuration=None):  # noqa: E501
        """AnalyticsProductSKU - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._sku = None
        self._last_updated = None
        self.discriminator = None

        self.id = id
        self.sku = sku
        self.last_updated = last_updated

    @property
    def id(self):
        """Gets the id of this AnalyticsProductSKU.  # noqa: E501

        The ID of the SKU linked to the analytics-level product.  # noqa: E501

        :return: The id of this AnalyticsProductSKU.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AnalyticsProductSKU.

        The ID of the SKU linked to the analytics-level product.  # noqa: E501

        :param id: The id of this AnalyticsProductSKU.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def sku(self):
        """Gets the sku of this AnalyticsProductSKU.  # noqa: E501

        The SKU linked to the analytics-level product.  # noqa: E501

        :return: The sku of this AnalyticsProductSKU.  # noqa: E501
        :rtype: str
        """
        return self._sku

    @sku.setter
    def sku(self, sku):
        """Sets the sku of this AnalyticsProductSKU.

        The SKU linked to the analytics-level product.  # noqa: E501

        :param sku: The sku of this AnalyticsProductSKU.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and sku is None:  # noqa: E501
            raise ValueError("Invalid value for `sku`, must not be `None`")  # noqa: E501

        self._sku = sku

    @property
    def last_updated(self):
        """Gets the last_updated of this AnalyticsProductSKU.  # noqa: E501

        Values in UTC for the date the SKU linked to the analytics-level product was last updated.  # noqa: E501

        :return: The last_updated of this AnalyticsProductSKU.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this AnalyticsProductSKU.

        Values in UTC for the date the SKU linked to the analytics-level product was last updated.  # noqa: E501

        :param last_updated: The last_updated of this AnalyticsProductSKU.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and last_updated is None:  # noqa: E501
            raise ValueError("Invalid value for `last_updated`, must not be `None`")  # noqa: E501

        self._last_updated = last_updated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AnalyticsProductSKU):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AnalyticsProductSKU):
            return True

        return self.to_dict() != other.to_dict()
