# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ApplicationAnalyticsDataPoint(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'start_time': 'datetime',
        'end_time': 'datetime',
        'total_revenue': 'AnalyticsDataPoint',
        'sessions_count': 'AnalyticsDataPoint',
        'avg_items_per_session': 'AnalyticsDataPoint',
        'avg_session_value': 'AnalyticsDataPoint',
        'total_discounts': 'float',
        'coupons_count': 'float'
    }

    attribute_map = {
        'start_time': 'startTime',
        'end_time': 'endTime',
        'total_revenue': 'totalRevenue',
        'sessions_count': 'sessionsCount',
        'avg_items_per_session': 'avgItemsPerSession',
        'avg_session_value': 'avgSessionValue',
        'total_discounts': 'totalDiscounts',
        'coupons_count': 'couponsCount'
    }

    def __init__(self, start_time=None, end_time=None, total_revenue=None, sessions_count=None, avg_items_per_session=None, avg_session_value=None, total_discounts=None, coupons_count=None, local_vars_configuration=None):  # noqa: E501
        """ApplicationAnalyticsDataPoint - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._start_time = None
        self._end_time = None
        self._total_revenue = None
        self._sessions_count = None
        self._avg_items_per_session = None
        self._avg_session_value = None
        self._total_discounts = None
        self._coupons_count = None
        self.discriminator = None

        self.start_time = start_time
        self.end_time = end_time
        if total_revenue is not None:
            self.total_revenue = total_revenue
        if sessions_count is not None:
            self.sessions_count = sessions_count
        if avg_items_per_session is not None:
            self.avg_items_per_session = avg_items_per_session
        if avg_session_value is not None:
            self.avg_session_value = avg_session_value
        if total_discounts is not None:
            self.total_discounts = total_discounts
        if coupons_count is not None:
            self.coupons_count = coupons_count

    @property
    def start_time(self):
        """Gets the start_time of this ApplicationAnalyticsDataPoint.  # noqa: E501

        The start of the aggregation time frame in UTC.  # noqa: E501

        :return: The start_time of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this ApplicationAnalyticsDataPoint.

        The start of the aggregation time frame in UTC.  # noqa: E501

        :param start_time: The start_time of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and start_time is None:  # noqa: E501
            raise ValueError("Invalid value for `start_time`, must not be `None`")  # noqa: E501

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this ApplicationAnalyticsDataPoint.  # noqa: E501

        The end of the aggregation time frame in UTC.  # noqa: E501

        :return: The end_time of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this ApplicationAnalyticsDataPoint.

        The end of the aggregation time frame in UTC.  # noqa: E501

        :param end_time: The end_time of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and end_time is None:  # noqa: E501
            raise ValueError("Invalid value for `end_time`, must not be `None`")  # noqa: E501

        self._end_time = end_time

    @property
    def total_revenue(self):
        """Gets the total_revenue of this ApplicationAnalyticsDataPoint.  # noqa: E501


        :return: The total_revenue of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: AnalyticsDataPoint
        """
        return self._total_revenue

    @total_revenue.setter
    def total_revenue(self, total_revenue):
        """Sets the total_revenue of this ApplicationAnalyticsDataPoint.


        :param total_revenue: The total_revenue of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: AnalyticsDataPoint
        """

        self._total_revenue = total_revenue

    @property
    def sessions_count(self):
        """Gets the sessions_count of this ApplicationAnalyticsDataPoint.  # noqa: E501


        :return: The sessions_count of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: AnalyticsDataPoint
        """
        return self._sessions_count

    @sessions_count.setter
    def sessions_count(self, sessions_count):
        """Sets the sessions_count of this ApplicationAnalyticsDataPoint.


        :param sessions_count: The sessions_count of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: AnalyticsDataPoint
        """

        self._sessions_count = sessions_count

    @property
    def avg_items_per_session(self):
        """Gets the avg_items_per_session of this ApplicationAnalyticsDataPoint.  # noqa: E501


        :return: The avg_items_per_session of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: AnalyticsDataPoint
        """
        return self._avg_items_per_session

    @avg_items_per_session.setter
    def avg_items_per_session(self, avg_items_per_session):
        """Sets the avg_items_per_session of this ApplicationAnalyticsDataPoint.


        :param avg_items_per_session: The avg_items_per_session of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: AnalyticsDataPoint
        """

        self._avg_items_per_session = avg_items_per_session

    @property
    def avg_session_value(self):
        """Gets the avg_session_value of this ApplicationAnalyticsDataPoint.  # noqa: E501


        :return: The avg_session_value of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: AnalyticsDataPoint
        """
        return self._avg_session_value

    @avg_session_value.setter
    def avg_session_value(self, avg_session_value):
        """Sets the avg_session_value of this ApplicationAnalyticsDataPoint.


        :param avg_session_value: The avg_session_value of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: AnalyticsDataPoint
        """

        self._avg_session_value = avg_session_value

    @property
    def total_discounts(self):
        """Gets the total_discounts of this ApplicationAnalyticsDataPoint.  # noqa: E501

        The total value of discounts given for cart items in influenced sessions.  # noqa: E501

        :return: The total_discounts of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: float
        """
        return self._total_discounts

    @total_discounts.setter
    def total_discounts(self, total_discounts):
        """Sets the total_discounts of this ApplicationAnalyticsDataPoint.

        The total value of discounts given for cart items in influenced sessions.  # noqa: E501

        :param total_discounts: The total_discounts of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: float
        """

        self._total_discounts = total_discounts

    @property
    def coupons_count(self):
        """Gets the coupons_count of this ApplicationAnalyticsDataPoint.  # noqa: E501

        The number of times a coupon was successfully redeemed in influenced sessions.  # noqa: E501

        :return: The coupons_count of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :rtype: float
        """
        return self._coupons_count

    @coupons_count.setter
    def coupons_count(self, coupons_count):
        """Sets the coupons_count of this ApplicationAnalyticsDataPoint.

        The number of times a coupon was successfully redeemed in influenced sessions.  # noqa: E501

        :param coupons_count: The coupons_count of this ApplicationAnalyticsDataPoint.  # noqa: E501
        :type: float
        """

        self._coupons_count = coupons_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ApplicationAnalyticsDataPoint):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ApplicationAnalyticsDataPoint):
            return True

        return self.to_dict() != other.to_dict()
