# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class Audience(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'int',
        'id': 'int',
        'created': 'datetime',
        'name': 'str',
        'sandbox': 'bool',
        'description': 'str',
        'integration': 'str',
        'integration_id': 'str',
        'created_in3rd_party': 'bool',
        'last_update': 'datetime'
    }

    attribute_map = {
        'account_id': 'accountId',
        'id': 'id',
        'created': 'created',
        'name': 'name',
        'sandbox': 'sandbox',
        'description': 'description',
        'integration': 'integration',
        'integration_id': 'integrationId',
        'created_in3rd_party': 'createdIn3rdParty',
        'last_update': 'lastUpdate'
    }

    def __init__(self, account_id=None, id=None, created=None, name=None, sandbox=None, description=None, integration=None, integration_id=None, created_in3rd_party=None, last_update=None, local_vars_configuration=None):  # noqa: E501
        """Audience - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._id = None
        self._created = None
        self._name = None
        self._sandbox = None
        self._description = None
        self._integration = None
        self._integration_id = None
        self._created_in3rd_party = None
        self._last_update = None
        self.discriminator = None

        self.account_id = account_id
        self.id = id
        self.created = created
        self.name = name
        if sandbox is not None:
            self.sandbox = sandbox
        if description is not None:
            self.description = description
        if integration is not None:
            self.integration = integration
        if integration_id is not None:
            self.integration_id = integration_id
        if created_in3rd_party is not None:
            self.created_in3rd_party = created_in3rd_party
        if last_update is not None:
            self.last_update = last_update

    @property
    def account_id(self):
        """Gets the account_id of this Audience.  # noqa: E501

        The ID of the account that owns this entity.  # noqa: E501

        :return: The account_id of this Audience.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this Audience.

        The ID of the account that owns this entity.  # noqa: E501

        :param account_id: The account_id of this Audience.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def id(self):
        """Gets the id of this Audience.  # noqa: E501

        Internal ID of this entity.  # noqa: E501

        :return: The id of this Audience.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Audience.

        Internal ID of this entity.  # noqa: E501

        :param id: The id of this Audience.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created(self):
        """Gets the created of this Audience.  # noqa: E501

        The time this entity was created.  # noqa: E501

        :return: The created of this Audience.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this Audience.

        The time this entity was created.  # noqa: E501

        :param created: The created of this Audience.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def name(self):
        """Gets the name of this Audience.  # noqa: E501

        The human-friendly display name for this audience.  # noqa: E501

        :return: The name of this Audience.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Audience.

        The human-friendly display name for this audience.  # noqa: E501

        :param name: The name of this Audience.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def sandbox(self):
        """Gets the sandbox of this Audience.  # noqa: E501

        Indicates if this is a live or sandbox Application.  # noqa: E501

        :return: The sandbox of this Audience.  # noqa: E501
        :rtype: bool
        """
        return self._sandbox

    @sandbox.setter
    def sandbox(self, sandbox):
        """Sets the sandbox of this Audience.

        Indicates if this is a live or sandbox Application.  # noqa: E501

        :param sandbox: The sandbox of this Audience.  # noqa: E501
        :type: bool
        """

        self._sandbox = sandbox

    @property
    def description(self):
        """Gets the description of this Audience.  # noqa: E501

        A description of the audience.  # noqa: E501

        :return: The description of this Audience.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Audience.

        A description of the audience.  # noqa: E501

        :param description: The description of this Audience.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def integration(self):
        """Gets the integration of this Audience.  # noqa: E501

        The Talon.One-supported [3rd-party platform](https://docs.talon.one/docs/dev/technology-partners/overview) that this audience was created in.  For example, `mParticle`, `Segment`, `Selligent`, `Braze`, or `Iterable`.  **Note:** If you do not integrate with any of these platforms, do not use this property.   # noqa: E501

        :return: The integration of this Audience.  # noqa: E501
        :rtype: str
        """
        return self._integration

    @integration.setter
    def integration(self, integration):
        """Sets the integration of this Audience.

        The Talon.One-supported [3rd-party platform](https://docs.talon.one/docs/dev/technology-partners/overview) that this audience was created in.  For example, `mParticle`, `Segment`, `Selligent`, `Braze`, or `Iterable`.  **Note:** If you do not integrate with any of these platforms, do not use this property.   # noqa: E501

        :param integration: The integration of this Audience.  # noqa: E501
        :type: str
        """

        self._integration = integration

    @property
    def integration_id(self):
        """Gets the integration_id of this Audience.  # noqa: E501

        The ID of this audience in the third-party integration.  **Note:** To create an audience that doesn't come from a 3rd party platform, do not use this property.   # noqa: E501

        :return: The integration_id of this Audience.  # noqa: E501
        :rtype: str
        """
        return self._integration_id

    @integration_id.setter
    def integration_id(self, integration_id):
        """Sets the integration_id of this Audience.

        The ID of this audience in the third-party integration.  **Note:** To create an audience that doesn't come from a 3rd party platform, do not use this property.   # noqa: E501

        :param integration_id: The integration_id of this Audience.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                integration_id is not None and len(integration_id) > 1000):
            raise ValueError("Invalid value for `integration_id`, length must be less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                integration_id is not None and len(integration_id) < 1):
            raise ValueError("Invalid value for `integration_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._integration_id = integration_id

    @property
    def created_in3rd_party(self):
        """Gets the created_in3rd_party of this Audience.  # noqa: E501

        Determines if this audience is a 3rd party audience or not.  # noqa: E501

        :return: The created_in3rd_party of this Audience.  # noqa: E501
        :rtype: bool
        """
        return self._created_in3rd_party

    @created_in3rd_party.setter
    def created_in3rd_party(self, created_in3rd_party):
        """Sets the created_in3rd_party of this Audience.

        Determines if this audience is a 3rd party audience or not.  # noqa: E501

        :param created_in3rd_party: The created_in3rd_party of this Audience.  # noqa: E501
        :type: bool
        """

        self._created_in3rd_party = created_in3rd_party

    @property
    def last_update(self):
        """Gets the last_update of this Audience.  # noqa: E501

        The last time that the audience memberships changed.  # noqa: E501

        :return: The last_update of this Audience.  # noqa: E501
        :rtype: datetime
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this Audience.

        The last time that the audience memberships changed.  # noqa: E501

        :param last_update: The last_update of this Audience.  # noqa: E501
        :type: datetime
        """

        self._last_update = last_update

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Audience):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Audience):
            return True

        return self.to_dict() != other.to_dict()
