# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class BulkOperationOnCampaigns(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'operation': 'str',
        'campaign_ids': 'list[int]',
        'activate_at': 'datetime'
    }

    attribute_map = {
        'operation': 'operation',
        'campaign_ids': 'campaignIds',
        'activate_at': 'activateAt'
    }

    def __init__(self, operation=None, campaign_ids=None, activate_at=None, local_vars_configuration=None):  # noqa: E501
        """BulkOperationOnCampaigns - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._operation = None
        self._campaign_ids = None
        self._activate_at = None
        self.discriminator = None

        self.operation = operation
        self.campaign_ids = campaign_ids
        if activate_at is not None:
            self.activate_at = activate_at

    @property
    def operation(self):
        """Gets the operation of this BulkOperationOnCampaigns.  # noqa: E501

        The operation to perform on the specified campaign IDs.   # noqa: E501

        :return: The operation of this BulkOperationOnCampaigns.  # noqa: E501
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this BulkOperationOnCampaigns.

        The operation to perform on the specified campaign IDs.   # noqa: E501

        :param operation: The operation of this BulkOperationOnCampaigns.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and operation is None:  # noqa: E501
            raise ValueError("Invalid value for `operation`, must not be `None`")  # noqa: E501
        allowed_values = ["disable", "delete", "activate_revision"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and operation not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `operation` ({0}), must be one of {1}"  # noqa: E501
                .format(operation, allowed_values)
            )

        self._operation = operation

    @property
    def campaign_ids(self):
        """Gets the campaign_ids of this BulkOperationOnCampaigns.  # noqa: E501

        The list of campaign IDs on which the operation will be performed.  # noqa: E501

        :return: The campaign_ids of this BulkOperationOnCampaigns.  # noqa: E501
        :rtype: list[int]
        """
        return self._campaign_ids

    @campaign_ids.setter
    def campaign_ids(self, campaign_ids):
        """Sets the campaign_ids of this BulkOperationOnCampaigns.

        The list of campaign IDs on which the operation will be performed.  # noqa: E501

        :param campaign_ids: The campaign_ids of this BulkOperationOnCampaigns.  # noqa: E501
        :type: list[int]
        """
        if self.local_vars_configuration.client_side_validation and campaign_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `campaign_ids`, must not be `None`")  # noqa: E501

        self._campaign_ids = campaign_ids

    @property
    def activate_at(self):
        """Gets the activate_at of this BulkOperationOnCampaigns.  # noqa: E501

        Timestamp when the revisions are finalized after the `activate_revision` operation. The current time is used when left blank.  **Note:** It must be an RFC3339 timestamp string.   # noqa: E501

        :return: The activate_at of this BulkOperationOnCampaigns.  # noqa: E501
        :rtype: datetime
        """
        return self._activate_at

    @activate_at.setter
    def activate_at(self, activate_at):
        """Sets the activate_at of this BulkOperationOnCampaigns.

        Timestamp when the revisions are finalized after the `activate_revision` operation. The current time is used when left blank.  **Note:** It must be an RFC3339 timestamp string.   # noqa: E501

        :param activate_at: The activate_at of this BulkOperationOnCampaigns.  # noqa: E501
        :type: datetime
        """

        self._activate_at = activate_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BulkOperationOnCampaigns):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BulkOperationOnCampaigns):
            return True

        return self.to_dict() != other.to_dict()
