# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CampaignBudget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'action': 'str',
        'limit': 'float',
        'counter': 'float'
    }

    attribute_map = {
        'action': 'action',
        'limit': 'limit',
        'counter': 'counter'
    }

    def __init__(self, action=None, limit=None, counter=None, local_vars_configuration=None):  # noqa: E501
        """CampaignBudget - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._action = None
        self._limit = None
        self._counter = None
        self.discriminator = None

        self.action = action
        self.limit = limit
        self.counter = counter

    @property
    def action(self):
        """Gets the action of this CampaignBudget.  # noqa: E501

        The limitable action to which this limit applies. For example: - `setDiscount` - `setDiscountEffect` - `redeemCoupon` - `createCoupon`   # noqa: E501

        :return: The action of this CampaignBudget.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this CampaignBudget.

        The limitable action to which this limit applies. For example: - `setDiscount` - `setDiscountEffect` - `redeemCoupon` - `createCoupon`   # noqa: E501

        :param action: The action of this CampaignBudget.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and action is None:  # noqa: E501
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501

        self._action = action

    @property
    def limit(self):
        """Gets the limit of this CampaignBudget.  # noqa: E501

        The value to set for the limit.  # noqa: E501

        :return: The limit of this CampaignBudget.  # noqa: E501
        :rtype: float
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this CampaignBudget.

        The value to set for the limit.  # noqa: E501

        :param limit: The limit of this CampaignBudget.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and limit is None:  # noqa: E501
            raise ValueError("Invalid value for `limit`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                limit is not None and limit < 0):  # noqa: E501
            raise ValueError("Invalid value for `limit`, must be a value greater than or equal to `0`")  # noqa: E501

        self._limit = limit

    @property
    def counter(self):
        """Gets the counter of this CampaignBudget.  # noqa: E501

        The number of occurrences of the limited action in the context of the campaign.  # noqa: E501

        :return: The counter of this CampaignBudget.  # noqa: E501
        :rtype: float
        """
        return self._counter

    @counter.setter
    def counter(self, counter):
        """Sets the counter of this CampaignBudget.

        The number of occurrences of the limited action in the context of the campaign.  # noqa: E501

        :param counter: The counter of this CampaignBudget.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and counter is None:  # noqa: E501
            raise ValueError("Invalid value for `counter`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                counter is not None and counter < 0):  # noqa: E501
            raise ValueError("Invalid value for `counter`, must be a value greater than or equal to `0`")  # noqa: E501

        self._counter = counter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignBudget):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignBudget):
            return True

        return self.to_dict() != other.to_dict()
