# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CampaignEvaluationTreeChangedNotification(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'application_id': 'int',
        'old_evaluation_tree': 'CampaignSet',
        'evaluation_tree': 'CampaignSet'
    }

    attribute_map = {
        'application_id': 'applicationId',
        'old_evaluation_tree': 'oldEvaluationTree',
        'evaluation_tree': 'evaluationTree'
    }

    def __init__(self, application_id=None, old_evaluation_tree=None, evaluation_tree=None, local_vars_configuration=None):  # noqa: E501
        """CampaignEvaluationTreeChangedNotification - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._application_id = None
        self._old_evaluation_tree = None
        self._evaluation_tree = None
        self.discriminator = None

        self.application_id = application_id
        if old_evaluation_tree is not None:
            self.old_evaluation_tree = old_evaluation_tree
        self.evaluation_tree = evaluation_tree

    @property
    def application_id(self):
        """Gets the application_id of this CampaignEvaluationTreeChangedNotification.  # noqa: E501

        The ID of the Application whose campaign evaluation tree changed.  # noqa: E501

        :return: The application_id of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :rtype: int
        """
        return self._application_id

    @application_id.setter
    def application_id(self, application_id):
        """Sets the application_id of this CampaignEvaluationTreeChangedNotification.

        The ID of the Application whose campaign evaluation tree changed.  # noqa: E501

        :param application_id: The application_id of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and application_id is None:  # noqa: E501
            raise ValueError("Invalid value for `application_id`, must not be `None`")  # noqa: E501

        self._application_id = application_id

    @property
    def old_evaluation_tree(self):
        """Gets the old_evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501


        :return: The old_evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :rtype: CampaignSet
        """
        return self._old_evaluation_tree

    @old_evaluation_tree.setter
    def old_evaluation_tree(self, old_evaluation_tree):
        """Sets the old_evaluation_tree of this CampaignEvaluationTreeChangedNotification.


        :param old_evaluation_tree: The old_evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :type: CampaignSet
        """

        self._old_evaluation_tree = old_evaluation_tree

    @property
    def evaluation_tree(self):
        """Gets the evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501


        :return: The evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :rtype: CampaignSet
        """
        return self._evaluation_tree

    @evaluation_tree.setter
    def evaluation_tree(self, evaluation_tree):
        """Sets the evaluation_tree of this CampaignEvaluationTreeChangedNotification.


        :param evaluation_tree: The evaluation_tree of this CampaignEvaluationTreeChangedNotification.  # noqa: E501
        :type: CampaignSet
        """
        if self.local_vars_configuration.client_side_validation and evaluation_tree is None:  # noqa: E501
            raise ValueError("Invalid value for `evaluation_tree`, must not be `None`")  # noqa: E501

        self._evaluation_tree = evaluation_tree

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignEvaluationTreeChangedNotification):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignEvaluationTreeChangedNotification):
            return True

        return self.to_dict() != other.to_dict()
