# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CampaignStateChangedNotification(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'campaign': 'Campaign',
        'old_state': 'str',
        'new_state': 'str',
        'ruleset': 'Ruleset'
    }

    attribute_map = {
        'campaign': 'campaign',
        'old_state': 'oldState',
        'new_state': 'newState',
        'ruleset': 'ruleset'
    }

    def __init__(self, campaign=None, old_state=None, new_state=None, ruleset=None, local_vars_configuration=None):  # noqa: E501
        """CampaignStateChangedNotification - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._campaign = None
        self._old_state = None
        self._new_state = None
        self._ruleset = None
        self.discriminator = None

        self.campaign = campaign
        self.old_state = old_state
        self.new_state = new_state
        if ruleset is not None:
            self.ruleset = ruleset

    @property
    def campaign(self):
        """Gets the campaign of this CampaignStateChangedNotification.  # noqa: E501


        :return: The campaign of this CampaignStateChangedNotification.  # noqa: E501
        :rtype: Campaign
        """
        return self._campaign

    @campaign.setter
    def campaign(self, campaign):
        """Sets the campaign of this CampaignStateChangedNotification.


        :param campaign: The campaign of this CampaignStateChangedNotification.  # noqa: E501
        :type: Campaign
        """
        if self.local_vars_configuration.client_side_validation and campaign is None:  # noqa: E501
            raise ValueError("Invalid value for `campaign`, must not be `None`")  # noqa: E501

        self._campaign = campaign

    @property
    def old_state(self):
        """Gets the old_state of this CampaignStateChangedNotification.  # noqa: E501

        The campaign's old state. Can be one of the following: ['running', 'disabled', 'scheduled', 'expired', 'archived']   # noqa: E501

        :return: The old_state of this CampaignStateChangedNotification.  # noqa: E501
        :rtype: str
        """
        return self._old_state

    @old_state.setter
    def old_state(self, old_state):
        """Sets the old_state of this CampaignStateChangedNotification.

        The campaign's old state. Can be one of the following: ['running', 'disabled', 'scheduled', 'expired', 'archived']   # noqa: E501

        :param old_state: The old_state of this CampaignStateChangedNotification.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and old_state is None:  # noqa: E501
            raise ValueError("Invalid value for `old_state`, must not be `None`")  # noqa: E501

        self._old_state = old_state

    @property
    def new_state(self):
        """Gets the new_state of this CampaignStateChangedNotification.  # noqa: E501

        The campaign's new state. Can be one of the following: ['running', 'disabled', 'scheduled', 'expired', 'archived']   # noqa: E501

        :return: The new_state of this CampaignStateChangedNotification.  # noqa: E501
        :rtype: str
        """
        return self._new_state

    @new_state.setter
    def new_state(self, new_state):
        """Sets the new_state of this CampaignStateChangedNotification.

        The campaign's new state. Can be one of the following: ['running', 'disabled', 'scheduled', 'expired', 'archived']   # noqa: E501

        :param new_state: The new_state of this CampaignStateChangedNotification.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and new_state is None:  # noqa: E501
            raise ValueError("Invalid value for `new_state`, must not be `None`")  # noqa: E501

        self._new_state = new_state

    @property
    def ruleset(self):
        """Gets the ruleset of this CampaignStateChangedNotification.  # noqa: E501


        :return: The ruleset of this CampaignStateChangedNotification.  # noqa: E501
        :rtype: Ruleset
        """
        return self._ruleset

    @ruleset.setter
    def ruleset(self, ruleset):
        """Sets the ruleset of this CampaignStateChangedNotification.


        :param ruleset: The ruleset of this CampaignStateChangedNotification.  # noqa: E501
        :type: Ruleset
        """

        self._ruleset = ruleset

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignStateChangedNotification):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignStateChangedNotification):
            return True

        return self.to_dict() != other.to_dict()
