# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CampaignTemplateCouponReservationSettings(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'reservation_limit': 'int',
        'is_reservation_mandatory': 'bool'
    }

    attribute_map = {
        'reservation_limit': 'reservationLimit',
        'is_reservation_mandatory': 'isReservationMandatory'
    }

    def __init__(self, reservation_limit=None, is_reservation_mandatory=False, local_vars_configuration=None):  # noqa: E501
        """CampaignTemplateCouponReservationSettings - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._reservation_limit = None
        self._is_reservation_mandatory = None
        self.discriminator = None

        if reservation_limit is not None:
            self.reservation_limit = reservation_limit
        if is_reservation_mandatory is not None:
            self.is_reservation_mandatory = is_reservation_mandatory

    @property
    def reservation_limit(self):
        """Gets the reservation_limit of this CampaignTemplateCouponReservationSettings.  # noqa: E501

        The number of reservations that can be made with this coupon code.   # noqa: E501

        :return: The reservation_limit of this CampaignTemplateCouponReservationSettings.  # noqa: E501
        :rtype: int
        """
        return self._reservation_limit

    @reservation_limit.setter
    def reservation_limit(self, reservation_limit):
        """Sets the reservation_limit of this CampaignTemplateCouponReservationSettings.

        The number of reservations that can be made with this coupon code.   # noqa: E501

        :param reservation_limit: The reservation_limit of this CampaignTemplateCouponReservationSettings.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                reservation_limit is not None and reservation_limit > 999999):  # noqa: E501
            raise ValueError("Invalid value for `reservation_limit`, must be a value less than or equal to `999999`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                reservation_limit is not None and reservation_limit < 0):  # noqa: E501
            raise ValueError("Invalid value for `reservation_limit`, must be a value greater than or equal to `0`")  # noqa: E501

        self._reservation_limit = reservation_limit

    @property
    def is_reservation_mandatory(self):
        """Gets the is_reservation_mandatory of this CampaignTemplateCouponReservationSettings.  # noqa: E501

        An indication of whether the code can be redeemed only if it has been reserved first.  # noqa: E501

        :return: The is_reservation_mandatory of this CampaignTemplateCouponReservationSettings.  # noqa: E501
        :rtype: bool
        """
        return self._is_reservation_mandatory

    @is_reservation_mandatory.setter
    def is_reservation_mandatory(self, is_reservation_mandatory):
        """Sets the is_reservation_mandatory of this CampaignTemplateCouponReservationSettings.

        An indication of whether the code can be redeemed only if it has been reserved first.  # noqa: E501

        :param is_reservation_mandatory: The is_reservation_mandatory of this CampaignTemplateCouponReservationSettings.  # noqa: E501
        :type: bool
        """

        self._is_reservation_mandatory = is_reservation_mandatory

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CampaignTemplateCouponReservationSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CampaignTemplateCouponReservationSettings):
            return True

        return self.to_dict() != other.to_dict()
