# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CodeGeneratorSettings(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'valid_characters': 'list[str]',
        'coupon_pattern': 'str'
    }

    attribute_map = {
        'valid_characters': 'validCharacters',
        'coupon_pattern': 'couponPattern'
    }

    def __init__(self, valid_characters=None, coupon_pattern=None, local_vars_configuration=None):  # noqa: E501
        """CodeGeneratorSettings - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._valid_characters = None
        self._coupon_pattern = None
        self.discriminator = None

        self.valid_characters = valid_characters
        self.coupon_pattern = coupon_pattern

    @property
    def valid_characters(self):
        """Gets the valid_characters of this CodeGeneratorSettings.  # noqa: E501

        List of characters used to generate the random parts of a code.   # noqa: E501

        :return: The valid_characters of this CodeGeneratorSettings.  # noqa: E501
        :rtype: list[str]
        """
        return self._valid_characters

    @valid_characters.setter
    def valid_characters(self, valid_characters):
        """Sets the valid_characters of this CodeGeneratorSettings.

        List of characters used to generate the random parts of a code.   # noqa: E501

        :param valid_characters: The valid_characters of this CodeGeneratorSettings.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and valid_characters is None:  # noqa: E501
            raise ValueError("Invalid value for `valid_characters`, must not be `None`")  # noqa: E501

        self._valid_characters = valid_characters

    @property
    def coupon_pattern(self):
        """Gets the coupon_pattern of this CodeGeneratorSettings.  # noqa: E501

        The pattern used to generate codes, such as coupon codes, referral codes, and loyalty cards. The character `#` is a placeholder and is replaced by a random character from the `validCharacters` set.   # noqa: E501

        :return: The coupon_pattern of this CodeGeneratorSettings.  # noqa: E501
        :rtype: str
        """
        return self._coupon_pattern

    @coupon_pattern.setter
    def coupon_pattern(self, coupon_pattern):
        """Sets the coupon_pattern of this CodeGeneratorSettings.

        The pattern used to generate codes, such as coupon codes, referral codes, and loyalty cards. The character `#` is a placeholder and is replaced by a random character from the `validCharacters` set.   # noqa: E501

        :param coupon_pattern: The coupon_pattern of this CodeGeneratorSettings.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and coupon_pattern is None:  # noqa: E501
            raise ValueError("Invalid value for `coupon_pattern`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                coupon_pattern is not None and len(coupon_pattern) > 100):
            raise ValueError("Invalid value for `coupon_pattern`, length must be less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                coupon_pattern is not None and len(coupon_pattern) < 3):
            raise ValueError("Invalid value for `coupon_pattern`, length must be greater than or equal to `3`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                coupon_pattern is not None and not re.search(r'^[A-Za-z0-9_#-]*$', coupon_pattern)):  # noqa: E501
            raise ValueError(r"Invalid value for `coupon_pattern`, must be a follow pattern or equal to `/^[A-Za-z0-9_#-]*$/`")  # noqa: E501

        self._coupon_pattern = coupon_pattern

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CodeGeneratorSettings):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CodeGeneratorSettings):
            return True

        return self.to_dict() != other.to_dict()
