# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class CreateApplicationAPIKey(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'title': 'str',
        'expires': 'datetime',
        'platform': 'str',
        'type': 'str',
        'time_offset': 'int'
    }

    attribute_map = {
        'title': 'title',
        'expires': 'expires',
        'platform': 'platform',
        'type': 'type',
        'time_offset': 'timeOffset'
    }

    def __init__(self, title=None, expires=None, platform=None, type=None, time_offset=None, local_vars_configuration=None):  # noqa: E501
        """CreateApplicationAPIKey - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._title = None
        self._expires = None
        self._platform = None
        self._type = None
        self._time_offset = None
        self.discriminator = None

        self.title = title
        self.expires = expires
        if platform is not None:
            self.platform = platform
        if type is not None:
            self.type = type
        if time_offset is not None:
            self.time_offset = time_offset

    @property
    def title(self):
        """Gets the title of this CreateApplicationAPIKey.  # noqa: E501

        Title of the API key.  # noqa: E501

        :return: The title of this CreateApplicationAPIKey.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this CreateApplicationAPIKey.

        Title of the API key.  # noqa: E501

        :param title: The title of this CreateApplicationAPIKey.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def expires(self):
        """Gets the expires of this CreateApplicationAPIKey.  # noqa: E501

        The date the API key expires.  # noqa: E501

        :return: The expires of this CreateApplicationAPIKey.  # noqa: E501
        :rtype: datetime
        """
        return self._expires

    @expires.setter
    def expires(self, expires):
        """Sets the expires of this CreateApplicationAPIKey.

        The date the API key expires.  # noqa: E501

        :param expires: The expires of this CreateApplicationAPIKey.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and expires is None:  # noqa: E501
            raise ValueError("Invalid value for `expires`, must not be `None`")  # noqa: E501

        self._expires = expires

    @property
    def platform(self):
        """Gets the platform of this CreateApplicationAPIKey.  # noqa: E501

        The third-party platform the API key is valid for. Use `none` for a generic API key to be used from your own integration layer.   # noqa: E501

        :return: The platform of this CreateApplicationAPIKey.  # noqa: E501
        :rtype: str
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this CreateApplicationAPIKey.

        The third-party platform the API key is valid for. Use `none` for a generic API key to be used from your own integration layer.   # noqa: E501

        :param platform: The platform of this CreateApplicationAPIKey.  # noqa: E501
        :type: str
        """
        allowed_values = ["none", "segment", "braze", "mparticle", "selligent", "iterable", "customer_engagement", "customer_data", "salesforce", "emarsys"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and platform not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `platform` ({0}), must be one of {1}"  # noqa: E501
                .format(platform, allowed_values)
            )

        self._platform = platform

    @property
    def type(self):
        """Gets the type of this CreateApplicationAPIKey.  # noqa: E501

        The API key type. Can be empty or `staging`.  Staging API keys can only be used for dry requests with the [Update customer session](https://docs.talon.one/integration-api#tag/Customer-sessions/operation/updateCustomerSessionV2) endpoint, [Update customer profile](https://docs.talon.one/integration-api#tag/Customer-profiles/operation/updateCustomerProfileV2) endpoint, and [Track event](https://docs.talon.one/integration-api#tag/Events/operation/trackEventV2) endpoint.  When using the _Update customer profile_ endpoint with a staging API key, the query parameter `runRuleEngine` must be `true`.   # noqa: E501

        :return: The type of this CreateApplicationAPIKey.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CreateApplicationAPIKey.

        The API key type. Can be empty or `staging`.  Staging API keys can only be used for dry requests with the [Update customer session](https://docs.talon.one/integration-api#tag/Customer-sessions/operation/updateCustomerSessionV2) endpoint, [Update customer profile](https://docs.talon.one/integration-api#tag/Customer-profiles/operation/updateCustomerProfileV2) endpoint, and [Track event](https://docs.talon.one/integration-api#tag/Events/operation/trackEventV2) endpoint.  When using the _Update customer profile_ endpoint with a staging API key, the query parameter `runRuleEngine` must be `true`.   # noqa: E501

        :param type: The type of this CreateApplicationAPIKey.  # noqa: E501
        :type: str
        """
        allowed_values = ["staging"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def time_offset(self):
        """Gets the time_offset of this CreateApplicationAPIKey.  # noqa: E501

        A time offset in nanoseconds associated with the API key. When making a request using the API key, rule evaluation is based on a date that is calculated by adding the offset to the current date.   # noqa: E501

        :return: The time_offset of this CreateApplicationAPIKey.  # noqa: E501
        :rtype: int
        """
        return self._time_offset

    @time_offset.setter
    def time_offset(self, time_offset):
        """Sets the time_offset of this CreateApplicationAPIKey.

        A time offset in nanoseconds associated with the API key. When making a request using the API key, rule evaluation is based on a date that is calculated by adding the offset to the current date.   # noqa: E501

        :param time_offset: The time_offset of this CreateApplicationAPIKey.  # noqa: E501
        :type: int
        """

        self._time_offset = time_offset

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateApplicationAPIKey):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateApplicationAPIKey):
            return True

        return self.to_dict() != other.to_dict()
