# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class DeductLoyaltyPointsEffectProps(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'rule_title': 'str',
        'program_id': 'int',
        'sub_ledger_id': 'str',
        'value': 'float',
        'transaction_uuid': 'str',
        'name': 'str',
        'card_identifier': 'str'
    }

    attribute_map = {
        'rule_title': 'ruleTitle',
        'program_id': 'programId',
        'sub_ledger_id': 'subLedgerId',
        'value': 'value',
        'transaction_uuid': 'transactionUUID',
        'name': 'name',
        'card_identifier': 'cardIdentifier'
    }

    def __init__(self, rule_title=None, program_id=None, sub_ledger_id=None, value=None, transaction_uuid=None, name=None, card_identifier=None, local_vars_configuration=None):  # noqa: E501
        """DeductLoyaltyPointsEffectProps - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._rule_title = None
        self._program_id = None
        self._sub_ledger_id = None
        self._value = None
        self._transaction_uuid = None
        self._name = None
        self._card_identifier = None
        self.discriminator = None

        self.rule_title = rule_title
        self.program_id = program_id
        self.sub_ledger_id = sub_ledger_id
        self.value = value
        self.transaction_uuid = transaction_uuid
        self.name = name
        if card_identifier is not None:
            self.card_identifier = card_identifier

    @property
    def rule_title(self):
        """Gets the rule_title of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The title of the rule that contained triggered this points deduction.  # noqa: E501

        :return: The rule_title of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._rule_title

    @rule_title.setter
    def rule_title(self, rule_title):
        """Sets the rule_title of this DeductLoyaltyPointsEffectProps.

        The title of the rule that contained triggered this points deduction.  # noqa: E501

        :param rule_title: The rule_title of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and rule_title is None:  # noqa: E501
            raise ValueError("Invalid value for `rule_title`, must not be `None`")  # noqa: E501

        self._rule_title = rule_title

    @property
    def program_id(self):
        """Gets the program_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The ID of the loyalty program where these points were added.  # noqa: E501

        :return: The program_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: int
        """
        return self._program_id

    @program_id.setter
    def program_id(self, program_id):
        """Sets the program_id of this DeductLoyaltyPointsEffectProps.

        The ID of the loyalty program where these points were added.  # noqa: E501

        :param program_id: The program_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and program_id is None:  # noqa: E501
            raise ValueError("Invalid value for `program_id`, must not be `None`")  # noqa: E501

        self._program_id = program_id

    @property
    def sub_ledger_id(self):
        """Gets the sub_ledger_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The ID of the subledger within the loyalty program where these points were added.  # noqa: E501

        :return: The sub_ledger_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._sub_ledger_id

    @sub_ledger_id.setter
    def sub_ledger_id(self, sub_ledger_id):
        """Sets the sub_ledger_id of this DeductLoyaltyPointsEffectProps.

        The ID of the subledger within the loyalty program where these points were added.  # noqa: E501

        :param sub_ledger_id: The sub_ledger_id of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and sub_ledger_id is None:  # noqa: E501
            raise ValueError("Invalid value for `sub_ledger_id`, must not be `None`")  # noqa: E501

        self._sub_ledger_id = sub_ledger_id

    @property
    def value(self):
        """Gets the value of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The amount of points that were deducted.  # noqa: E501

        :return: The value of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this DeductLoyaltyPointsEffectProps.

        The amount of points that were deducted.  # noqa: E501

        :param value: The value of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and value is None:  # noqa: E501
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def transaction_uuid(self):
        """Gets the transaction_uuid of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The identifier of this deduction in the loyalty ledger.  # noqa: E501

        :return: The transaction_uuid of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._transaction_uuid

    @transaction_uuid.setter
    def transaction_uuid(self, transaction_uuid):
        """Sets the transaction_uuid of this DeductLoyaltyPointsEffectProps.

        The identifier of this deduction in the loyalty ledger.  # noqa: E501

        :param transaction_uuid: The transaction_uuid of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and transaction_uuid is None:  # noqa: E501
            raise ValueError("Invalid value for `transaction_uuid`, must not be `None`")  # noqa: E501

        self._transaction_uuid = transaction_uuid

    @property
    def name(self):
        """Gets the name of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The name property gets one of the following two values. It can be the loyalty program name or it can represent a reason for the respective deduction of loyalty points. The latter is an optional value defined in a deduction rule.   # noqa: E501

        :return: The name of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DeductLoyaltyPointsEffectProps.

        The name property gets one of the following two values. It can be the loyalty program name or it can represent a reason for the respective deduction of loyalty points. The latter is an optional value defined in a deduction rule.   # noqa: E501

        :param name: The name of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def card_identifier(self):
        """Gets the card_identifier of this DeductLoyaltyPointsEffectProps.  # noqa: E501

        The alphanumeric identifier of the loyalty card.   # noqa: E501

        :return: The card_identifier of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._card_identifier

    @card_identifier.setter
    def card_identifier(self, card_identifier):
        """Sets the card_identifier of this DeductLoyaltyPointsEffectProps.

        The alphanumeric identifier of the loyalty card.   # noqa: E501

        :param card_identifier: The card_identifier of this DeductLoyaltyPointsEffectProps.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                card_identifier is not None and len(card_identifier) > 108):
            raise ValueError("Invalid value for `card_identifier`, length must be less than or equal to `108`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                card_identifier is not None and not re.search(r'^[A-Za-z0-9_-]*$', card_identifier)):  # noqa: E501
            raise ValueError(r"Invalid value for `card_identifier`, must be a follow pattern or equal to `/^[A-Za-z0-9_-]*$/`")  # noqa: E501

        self._card_identifier = card_identifier

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeductLoyaltyPointsEffectProps):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DeductLoyaltyPointsEffectProps):
            return True

        return self.to_dict() != other.to_dict()
