# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class IntegrationCustomerSessionResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'customer_session': 'CustomerSessionV2',
        'effects': 'list[Effect]'
    }

    attribute_map = {
        'customer_session': 'customerSession',
        'effects': 'effects'
    }

    def __init__(self, customer_session=None, effects=None, local_vars_configuration=None):  # noqa: E501
        """IntegrationCustomerSessionResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._customer_session = None
        self._effects = None
        self.discriminator = None

        if customer_session is not None:
            self.customer_session = customer_session
        if effects is not None:
            self.effects = effects

    @property
    def customer_session(self):
        """Gets the customer_session of this IntegrationCustomerSessionResponse.  # noqa: E501


        :return: The customer_session of this IntegrationCustomerSessionResponse.  # noqa: E501
        :rtype: CustomerSessionV2
        """
        return self._customer_session

    @customer_session.setter
    def customer_session(self, customer_session):
        """Sets the customer_session of this IntegrationCustomerSessionResponse.


        :param customer_session: The customer_session of this IntegrationCustomerSessionResponse.  # noqa: E501
        :type: CustomerSessionV2
        """

        self._customer_session = customer_session

    @property
    def effects(self):
        """Gets the effects of this IntegrationCustomerSessionResponse.  # noqa: E501

        The returned effects.  **Note:** This endpoint returns only the effects that are valid after any rollback effects and their corresponding non-rollback effects are removed.   # noqa: E501

        :return: The effects of this IntegrationCustomerSessionResponse.  # noqa: E501
        :rtype: list[Effect]
        """
        return self._effects

    @effects.setter
    def effects(self, effects):
        """Sets the effects of this IntegrationCustomerSessionResponse.

        The returned effects.  **Note:** This endpoint returns only the effects that are valid after any rollback effects and their corresponding non-rollback effects are removed.   # noqa: E501

        :param effects: The effects of this IntegrationCustomerSessionResponse.  # noqa: E501
        :type: list[Effect]
        """

        self._effects = effects

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, IntegrationCustomerSessionResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, IntegrationCustomerSessionResponse):
            return True

        return self.to_dict() != other.to_dict()
