# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LedgerEntry(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'created': 'datetime',
        'profile_id': 'str',
        'account_id': 'int',
        'loyalty_program_id': 'int',
        'event_id': 'int',
        'amount': 'int',
        'reason': 'str',
        'expiry_date': 'datetime',
        'reference_id': 'int'
    }

    attribute_map = {
        'id': 'id',
        'created': 'created',
        'profile_id': 'profileId',
        'account_id': 'accountId',
        'loyalty_program_id': 'loyaltyProgramId',
        'event_id': 'eventId',
        'amount': 'amount',
        'reason': 'reason',
        'expiry_date': 'expiryDate',
        'reference_id': 'referenceId'
    }

    def __init__(self, id=None, created=None, profile_id=None, account_id=None, loyalty_program_id=None, event_id=None, amount=None, reason=None, expiry_date=None, reference_id=None, local_vars_configuration=None):  # noqa: E501
        """LedgerEntry - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created = None
        self._profile_id = None
        self._account_id = None
        self._loyalty_program_id = None
        self._event_id = None
        self._amount = None
        self._reason = None
        self._expiry_date = None
        self._reference_id = None
        self.discriminator = None

        self.id = id
        self.created = created
        self.profile_id = profile_id
        self.account_id = account_id
        self.loyalty_program_id = loyalty_program_id
        self.event_id = event_id
        self.amount = amount
        self.reason = reason
        self.expiry_date = expiry_date
        if reference_id is not None:
            self.reference_id = reference_id

    @property
    def id(self):
        """Gets the id of this LedgerEntry.  # noqa: E501

        Internal ID of this entity.  # noqa: E501

        :return: The id of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LedgerEntry.

        Internal ID of this entity.  # noqa: E501

        :param id: The id of this LedgerEntry.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created(self):
        """Gets the created of this LedgerEntry.  # noqa: E501

        The time this entity was created.  # noqa: E501

        :return: The created of this LedgerEntry.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this LedgerEntry.

        The time this entity was created.  # noqa: E501

        :param created: The created of this LedgerEntry.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def profile_id(self):
        """Gets the profile_id of this LedgerEntry.  # noqa: E501

        ID of the customer profile set by your integration layer.  **Note:** If the customer does not yet have a known `profileId`, we recommend you use a guest `profileId`.   # noqa: E501

        :return: The profile_id of this LedgerEntry.  # noqa: E501
        :rtype: str
        """
        return self._profile_id

    @profile_id.setter
    def profile_id(self, profile_id):
        """Sets the profile_id of this LedgerEntry.

        ID of the customer profile set by your integration layer.  **Note:** If the customer does not yet have a known `profileId`, we recommend you use a guest `profileId`.   # noqa: E501

        :param profile_id: The profile_id of this LedgerEntry.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and profile_id is None:  # noqa: E501
            raise ValueError("Invalid value for `profile_id`, must not be `None`")  # noqa: E501

        self._profile_id = profile_id

    @property
    def account_id(self):
        """Gets the account_id of this LedgerEntry.  # noqa: E501

        The ID of the Talon.One account that owns this profile.  # noqa: E501

        :return: The account_id of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this LedgerEntry.

        The ID of the Talon.One account that owns this profile.  # noqa: E501

        :param account_id: The account_id of this LedgerEntry.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this LedgerEntry.  # noqa: E501

        ID of the ledger.  # noqa: E501

        :return: The loyalty_program_id of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this LedgerEntry.

        ID of the ledger.  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this LedgerEntry.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and loyalty_program_id is None:  # noqa: E501
            raise ValueError("Invalid value for `loyalty_program_id`, must not be `None`")  # noqa: E501

        self._loyalty_program_id = loyalty_program_id

    @property
    def event_id(self):
        """Gets the event_id of this LedgerEntry.  # noqa: E501

        ID of the related event.  # noqa: E501

        :return: The event_id of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._event_id

    @event_id.setter
    def event_id(self, event_id):
        """Sets the event_id of this LedgerEntry.

        ID of the related event.  # noqa: E501

        :param event_id: The event_id of this LedgerEntry.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and event_id is None:  # noqa: E501
            raise ValueError("Invalid value for `event_id`, must not be `None`")  # noqa: E501

        self._event_id = event_id

    @property
    def amount(self):
        """Gets the amount of this LedgerEntry.  # noqa: E501

        Amount of loyalty points.  # noqa: E501

        :return: The amount of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this LedgerEntry.

        Amount of loyalty points.  # noqa: E501

        :param amount: The amount of this LedgerEntry.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and amount is None:  # noqa: E501
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def reason(self):
        """Gets the reason of this LedgerEntry.  # noqa: E501

        reason for awarding/deducting points.  # noqa: E501

        :return: The reason of this LedgerEntry.  # noqa: E501
        :rtype: str
        """
        return self._reason

    @reason.setter
    def reason(self, reason):
        """Sets the reason of this LedgerEntry.

        reason for awarding/deducting points.  # noqa: E501

        :param reason: The reason of this LedgerEntry.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and reason is None:  # noqa: E501
            raise ValueError("Invalid value for `reason`, must not be `None`")  # noqa: E501

        self._reason = reason

    @property
    def expiry_date(self):
        """Gets the expiry_date of this LedgerEntry.  # noqa: E501

        Expiration date of the points.  # noqa: E501

        :return: The expiry_date of this LedgerEntry.  # noqa: E501
        :rtype: datetime
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this LedgerEntry.

        Expiration date of the points.  # noqa: E501

        :param expiry_date: The expiry_date of this LedgerEntry.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and expiry_date is None:  # noqa: E501
            raise ValueError("Invalid value for `expiry_date`, must not be `None`")  # noqa: E501

        self._expiry_date = expiry_date

    @property
    def reference_id(self):
        """Gets the reference_id of this LedgerEntry.  # noqa: E501

        The ID of the balancing ledgerEntry.  # noqa: E501

        :return: The reference_id of this LedgerEntry.  # noqa: E501
        :rtype: int
        """
        return self._reference_id

    @reference_id.setter
    def reference_id(self, reference_id):
        """Sets the reference_id of this LedgerEntry.

        The ID of the balancing ledgerEntry.  # noqa: E501

        :param reference_id: The reference_id of this LedgerEntry.  # noqa: E501
        :type: int
        """

        self._reference_id = reference_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LedgerEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LedgerEntry):
            return True

        return self.to_dict() != other.to_dict()
