# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LibraryAttribute(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'entity': 'str',
        'name': 'str',
        'title': 'str',
        'type': 'str',
        'description': 'str',
        'presets': 'list[str]',
        'suggestions': 'list[str]'
    }

    attribute_map = {
        'entity': 'entity',
        'name': 'name',
        'title': 'title',
        'type': 'type',
        'description': 'description',
        'presets': 'presets',
        'suggestions': 'suggestions'
    }

    def __init__(self, entity=None, name=None, title=None, type=None, description=None, presets=None, suggestions=None, local_vars_configuration=None):  # noqa: E501
        """LibraryAttribute - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._entity = None
        self._name = None
        self._title = None
        self._type = None
        self._description = None
        self._presets = None
        self._suggestions = None
        self.discriminator = None

        self.entity = entity
        self.name = name
        self.title = title
        self.type = type
        self.description = description
        self.presets = presets
        self.suggestions = suggestions

    @property
    def entity(self):
        """Gets the entity of this LibraryAttribute.  # noqa: E501

        The name of the entity that can have this attribute. When creating or updating the entities of a given type, you can include an `attributes` object with keys corresponding to the `name` of the custom attributes for that type.  # noqa: E501

        :return: The entity of this LibraryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._entity

    @entity.setter
    def entity(self, entity):
        """Sets the entity of this LibraryAttribute.

        The name of the entity that can have this attribute. When creating or updating the entities of a given type, you can include an `attributes` object with keys corresponding to the `name` of the custom attributes for that type.  # noqa: E501

        :param entity: The entity of this LibraryAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and entity is None:  # noqa: E501
            raise ValueError("Invalid value for `entity`, must not be `None`")  # noqa: E501
        allowed_values = ["Application", "Campaign", "CustomerProfile", "CustomerSession", "CartItem", "Coupon", "Event"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and entity not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `entity` ({0}), must be one of {1}"  # noqa: E501
                .format(entity, allowed_values)
            )

        self._entity = entity

    @property
    def name(self):
        """Gets the name of this LibraryAttribute.  # noqa: E501

        The attribute name that will be used in API requests and Talang. E.g. if `name == \"region\"` then you would set the region attribute by including an `attributes.region` property in your request payload.   # noqa: E501

        :return: The name of this LibraryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LibraryAttribute.

        The attribute name that will be used in API requests and Talang. E.g. if `name == \"region\"` then you would set the region attribute by including an `attributes.region` property in your request payload.   # noqa: E501

        :param name: The name of this LibraryAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def title(self):
        """Gets the title of this LibraryAttribute.  # noqa: E501

        The human-readable name for the attribute that will be shown in the Campaign Manager. Like `name`, the combination of entity and title must also be unique.  # noqa: E501

        :return: The title of this LibraryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this LibraryAttribute.

        The human-readable name for the attribute that will be shown in the Campaign Manager. Like `name`, the combination of entity and title must also be unique.  # noqa: E501

        :param title: The title of this LibraryAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def type(self):
        """Gets the type of this LibraryAttribute.  # noqa: E501

        The data type of the attribute, a `time` attribute must be sent as a string that conforms to the [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp format.  # noqa: E501

        :return: The type of this LibraryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LibraryAttribute.

        The data type of the attribute, a `time` attribute must be sent as a string that conforms to the [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) timestamp format.  # noqa: E501

        :param type: The type of this LibraryAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["string", "number", "boolean", "time"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def description(self):
        """Gets the description of this LibraryAttribute.  # noqa: E501

        A description of the attribute.  # noqa: E501

        :return: The description of this LibraryAttribute.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this LibraryAttribute.

        A description of the attribute.  # noqa: E501

        :param description: The description of this LibraryAttribute.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def presets(self):
        """Gets the presets of this LibraryAttribute.  # noqa: E501

        The presets that indicate to which industry the attribute applies to.  # noqa: E501

        :return: The presets of this LibraryAttribute.  # noqa: E501
        :rtype: list[str]
        """
        return self._presets

    @presets.setter
    def presets(self, presets):
        """Sets the presets of this LibraryAttribute.

        The presets that indicate to which industry the attribute applies to.  # noqa: E501

        :param presets: The presets of this LibraryAttribute.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and presets is None:  # noqa: E501
            raise ValueError("Invalid value for `presets`, must not be `None`")  # noqa: E501

        self._presets = presets

    @property
    def suggestions(self):
        """Gets the suggestions of this LibraryAttribute.  # noqa: E501

        Short suggestions that are used to group attributes.  # noqa: E501

        :return: The suggestions of this LibraryAttribute.  # noqa: E501
        :rtype: list[str]
        """
        return self._suggestions

    @suggestions.setter
    def suggestions(self, suggestions):
        """Sets the suggestions of this LibraryAttribute.

        Short suggestions that are used to group attributes.  # noqa: E501

        :param suggestions: The suggestions of this LibraryAttribute.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and suggestions is None:  # noqa: E501
            raise ValueError("Invalid value for `suggestions`, must not be `None`")  # noqa: E501

        self._suggestions = suggestions

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LibraryAttribute):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LibraryAttribute):
            return True

        return self.to_dict() != other.to_dict()
