# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LoyaltyMembership(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'joined': 'datetime',
        'loyalty_program_id': 'int'
    }

    attribute_map = {
        'joined': 'joined',
        'loyalty_program_id': 'loyaltyProgramId'
    }

    def __init__(self, joined=None, loyalty_program_id=None, local_vars_configuration=None):  # noqa: E501
        """LoyaltyMembership - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._joined = None
        self._loyalty_program_id = None
        self.discriminator = None

        if joined is not None:
            self.joined = joined
        self.loyalty_program_id = loyalty_program_id

    @property
    def joined(self):
        """Gets the joined of this LoyaltyMembership.  # noqa: E501

        The moment in which the loyalty program was joined.  # noqa: E501

        :return: The joined of this LoyaltyMembership.  # noqa: E501
        :rtype: datetime
        """
        return self._joined

    @joined.setter
    def joined(self, joined):
        """Sets the joined of this LoyaltyMembership.

        The moment in which the loyalty program was joined.  # noqa: E501

        :param joined: The joined of this LoyaltyMembership.  # noqa: E501
        :type: datetime
        """

        self._joined = joined

    @property
    def loyalty_program_id(self):
        """Gets the loyalty_program_id of this LoyaltyMembership.  # noqa: E501

        The ID of the loyalty program belonging to this entity.  # noqa: E501

        :return: The loyalty_program_id of this LoyaltyMembership.  # noqa: E501
        :rtype: int
        """
        return self._loyalty_program_id

    @loyalty_program_id.setter
    def loyalty_program_id(self, loyalty_program_id):
        """Sets the loyalty_program_id of this LoyaltyMembership.

        The ID of the loyalty program belonging to this entity.  # noqa: E501

        :param loyalty_program_id: The loyalty_program_id of this LoyaltyMembership.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and loyalty_program_id is None:  # noqa: E501
            raise ValueError("Invalid value for `loyalty_program_id`, must not be `None`")  # noqa: E501

        self._loyalty_program_id = loyalty_program_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoyaltyMembership):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LoyaltyMembership):
            return True

        return self.to_dict() != other.to_dict()
