# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LoyaltyProgramLedgers(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'title': 'str',
        'name': 'str',
        'join_date': 'datetime',
        'ledger': 'LedgerInfo',
        'sub_ledgers': 'dict(str, LedgerInfo)'
    }

    attribute_map = {
        'id': 'id',
        'title': 'title',
        'name': 'name',
        'join_date': 'joinDate',
        'ledger': 'ledger',
        'sub_ledgers': 'subLedgers'
    }

    def __init__(self, id=None, title=None, name=None, join_date=None, ledger=None, sub_ledgers=None, local_vars_configuration=None):  # noqa: E501
        """LoyaltyProgramLedgers - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._title = None
        self._name = None
        self._join_date = None
        self._ledger = None
        self._sub_ledgers = None
        self.discriminator = None

        self.id = id
        self.title = title
        self.name = name
        if join_date is not None:
            self.join_date = join_date
        self.ledger = ledger
        if sub_ledgers is not None:
            self.sub_ledgers = sub_ledgers

    @property
    def id(self):
        """Gets the id of this LoyaltyProgramLedgers.  # noqa: E501

        The internal ID of loyalty program.  # noqa: E501

        :return: The id of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LoyaltyProgramLedgers.

        The internal ID of loyalty program.  # noqa: E501

        :param id: The id of this LoyaltyProgramLedgers.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def title(self):
        """Gets the title of this LoyaltyProgramLedgers.  # noqa: E501

        Visible name of loyalty program.  # noqa: E501

        :return: The title of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this LoyaltyProgramLedgers.

        Visible name of loyalty program.  # noqa: E501

        :param title: The title of this LoyaltyProgramLedgers.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def name(self):
        """Gets the name of this LoyaltyProgramLedgers.  # noqa: E501

        Internal name of loyalty program.  # noqa: E501

        :return: The name of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LoyaltyProgramLedgers.

        Internal name of loyalty program.  # noqa: E501

        :param name: The name of this LoyaltyProgramLedgers.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def join_date(self):
        """Gets the join_date of this LoyaltyProgramLedgers.  # noqa: E501

        The date on which the customer joined the loyalty program in RFC3339.  **Note**: This is in the loyalty program's time zone.   # noqa: E501

        :return: The join_date of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: datetime
        """
        return self._join_date

    @join_date.setter
    def join_date(self, join_date):
        """Sets the join_date of this LoyaltyProgramLedgers.

        The date on which the customer joined the loyalty program in RFC3339.  **Note**: This is in the loyalty program's time zone.   # noqa: E501

        :param join_date: The join_date of this LoyaltyProgramLedgers.  # noqa: E501
        :type: datetime
        """

        self._join_date = join_date

    @property
    def ledger(self):
        """Gets the ledger of this LoyaltyProgramLedgers.  # noqa: E501


        :return: The ledger of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: LedgerInfo
        """
        return self._ledger

    @ledger.setter
    def ledger(self, ledger):
        """Sets the ledger of this LoyaltyProgramLedgers.


        :param ledger: The ledger of this LoyaltyProgramLedgers.  # noqa: E501
        :type: LedgerInfo
        """
        if self.local_vars_configuration.client_side_validation and ledger is None:  # noqa: E501
            raise ValueError("Invalid value for `ledger`, must not be `None`")  # noqa: E501

        self._ledger = ledger

    @property
    def sub_ledgers(self):
        """Gets the sub_ledgers of this LoyaltyProgramLedgers.  # noqa: E501

        A map containing information about each loyalty subledger.  # noqa: E501

        :return: The sub_ledgers of this LoyaltyProgramLedgers.  # noqa: E501
        :rtype: dict(str, LedgerInfo)
        """
        return self._sub_ledgers

    @sub_ledgers.setter
    def sub_ledgers(self, sub_ledgers):
        """Sets the sub_ledgers of this LoyaltyProgramLedgers.

        A map containing information about each loyalty subledger.  # noqa: E501

        :param sub_ledgers: The sub_ledgers of this LoyaltyProgramLedgers.  # noqa: E501
        :type: dict(str, LedgerInfo)
        """

        self._sub_ledgers = sub_ledgers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoyaltyProgramLedgers):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LoyaltyProgramLedgers):
            return True

        return self.to_dict() != other.to_dict()
