# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you are reading this page at `https://mycompany.talon.one/docs/api/`, the URL for the [updateCustomerSession](https://docs.talon.one/integration-api/#operation/updateCustomerSessionV2) endpoint is `https://mycompany.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LoyaltyProjection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'projections': 'list[LoyaltyProjectionData]',
        'total_expiring_points': 'float',
        'total_activating_points': 'float'
    }

    attribute_map = {
        'projections': 'projections',
        'total_expiring_points': 'totalExpiringPoints',
        'total_activating_points': 'totalActivatingPoints'
    }

    def __init__(self, projections=None, total_expiring_points=None, total_activating_points=None, local_vars_configuration=None):  # noqa: E501
        """LoyaltyProjection - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._projections = None
        self._total_expiring_points = None
        self._total_activating_points = None
        self.discriminator = None

        if projections is not None:
            self.projections = projections
        self.total_expiring_points = total_expiring_points
        self.total_activating_points = total_activating_points

    @property
    def projections(self):
        """Gets the projections of this LoyaltyProjection.  # noqa: E501


        :return: The projections of this LoyaltyProjection.  # noqa: E501
        :rtype: list[LoyaltyProjectionData]
        """
        return self._projections

    @projections.setter
    def projections(self, projections):
        """Sets the projections of this LoyaltyProjection.


        :param projections: The projections of this LoyaltyProjection.  # noqa: E501
        :type: list[LoyaltyProjectionData]
        """

        self._projections = projections

    @property
    def total_expiring_points(self):
        """Gets the total_expiring_points of this LoyaltyProjection.  # noqa: E501

        Sum of points to be expired by the projection date set in the query parameter.  # noqa: E501

        :return: The total_expiring_points of this LoyaltyProjection.  # noqa: E501
        :rtype: float
        """
        return self._total_expiring_points

    @total_expiring_points.setter
    def total_expiring_points(self, total_expiring_points):
        """Sets the total_expiring_points of this LoyaltyProjection.

        Sum of points to be expired by the projection date set in the query parameter.  # noqa: E501

        :param total_expiring_points: The total_expiring_points of this LoyaltyProjection.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and total_expiring_points is None:  # noqa: E501
            raise ValueError("Invalid value for `total_expiring_points`, must not be `None`")  # noqa: E501

        self._total_expiring_points = total_expiring_points

    @property
    def total_activating_points(self):
        """Gets the total_activating_points of this LoyaltyProjection.  # noqa: E501

        Sum of points to be active by the projection date set in the query parameter.  # noqa: E501

        :return: The total_activating_points of this LoyaltyProjection.  # noqa: E501
        :rtype: float
        """
        return self._total_activating_points

    @total_activating_points.setter
    def total_activating_points(self, total_activating_points):
        """Sets the total_activating_points of this LoyaltyProjection.

        Sum of points to be active by the projection date set in the query parameter.  # noqa: E501

        :param total_activating_points: The total_activating_points of this LoyaltyProjection.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and total_activating_points is None:  # noqa: E501
            raise ValueError("Invalid value for `total_activating_points`, must not be `None`")  # noqa: E501

        self._total_activating_points = total_activating_points

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoyaltyProjection):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LoyaltyProjection):
            return True

        return self.to_dict() != other.to_dict()
