# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you are reading this page at `https://mycompany.talon.one/docs/api/`, the URL for the [updateCustomerSession](https://docs.talon.one/integration-api/#operation/updateCustomerSessionV2) endpoint is `https://mycompany.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class LoyaltyProjectionData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'date': 'datetime',
        'expiring_points': 'float',
        'activating_points': 'float',
        'projected_balance': 'float'
    }

    attribute_map = {
        'date': 'date',
        'expiring_points': 'expiringPoints',
        'activating_points': 'activatingPoints',
        'projected_balance': 'projectedBalance'
    }

    def __init__(self, date=None, expiring_points=None, activating_points=None, projected_balance=None, local_vars_configuration=None):  # noqa: E501
        """LoyaltyProjectionData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._date = None
        self._expiring_points = None
        self._activating_points = None
        self._projected_balance = None
        self.discriminator = None

        self.date = date
        self.expiring_points = expiring_points
        self.activating_points = activating_points
        self.projected_balance = projected_balance

    @property
    def date(self):
        """Gets the date of this LoyaltyProjectionData.  # noqa: E501

        Specific date of projection.  # noqa: E501

        :return: The date of this LoyaltyProjectionData.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this LoyaltyProjectionData.

        Specific date of projection.  # noqa: E501

        :param date: The date of this LoyaltyProjectionData.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and date is None:  # noqa: E501
            raise ValueError("Invalid value for `date`, must not be `None`")  # noqa: E501

        self._date = date

    @property
    def expiring_points(self):
        """Gets the expiring_points of this LoyaltyProjectionData.  # noqa: E501

        Points that will be expired by the specified date.  # noqa: E501

        :return: The expiring_points of this LoyaltyProjectionData.  # noqa: E501
        :rtype: float
        """
        return self._expiring_points

    @expiring_points.setter
    def expiring_points(self, expiring_points):
        """Sets the expiring_points of this LoyaltyProjectionData.

        Points that will be expired by the specified date.  # noqa: E501

        :param expiring_points: The expiring_points of this LoyaltyProjectionData.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and expiring_points is None:  # noqa: E501
            raise ValueError("Invalid value for `expiring_points`, must not be `None`")  # noqa: E501

        self._expiring_points = expiring_points

    @property
    def activating_points(self):
        """Gets the activating_points of this LoyaltyProjectionData.  # noqa: E501

        Points that will be active by the specified date.  # noqa: E501

        :return: The activating_points of this LoyaltyProjectionData.  # noqa: E501
        :rtype: float
        """
        return self._activating_points

    @activating_points.setter
    def activating_points(self, activating_points):
        """Sets the activating_points of this LoyaltyProjectionData.

        Points that will be active by the specified date.  # noqa: E501

        :param activating_points: The activating_points of this LoyaltyProjectionData.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and activating_points is None:  # noqa: E501
            raise ValueError("Invalid value for `activating_points`, must not be `None`")  # noqa: E501

        self._activating_points = activating_points

    @property
    def projected_balance(self):
        """Gets the projected_balance of this LoyaltyProjectionData.  # noqa: E501

        Current balance plus projected active points, minus expiring points.  # noqa: E501

        :return: The projected_balance of this LoyaltyProjectionData.  # noqa: E501
        :rtype: float
        """
        return self._projected_balance

    @projected_balance.setter
    def projected_balance(self, projected_balance):
        """Sets the projected_balance of this LoyaltyProjectionData.

        Current balance plus projected active points, minus expiring points.  # noqa: E501

        :param projected_balance: The projected_balance of this LoyaltyProjectionData.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and projected_balance is None:  # noqa: E501
            raise ValueError("Invalid value for `projected_balance`, must not be `None`")  # noqa: E501

        self._projected_balance = projected_balance

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoyaltyProjectionData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, LoyaltyProjectionData):
            return True

        return self.to_dict() != other.to_dict()
