# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class MessageLogEntries(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'next_cursor': 'str',
        'data': 'list[MessageLogEntry]'
    }

    attribute_map = {
        'next_cursor': 'nextCursor',
        'data': 'data'
    }

    def __init__(self, next_cursor=None, data=None, local_vars_configuration=None):  # noqa: E501
        """MessageLogEntries - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._next_cursor = None
        self._data = None
        self.discriminator = None

        if next_cursor is not None:
            self.next_cursor = next_cursor
        self.data = data

    @property
    def next_cursor(self):
        """Gets the next_cursor of this MessageLogEntries.  # noqa: E501

        The next value in the database.  **Note:** If this value is not present, it means that there are no more values in the database for this combination of request parameters.   # noqa: E501

        :return: The next_cursor of this MessageLogEntries.  # noqa: E501
        :rtype: str
        """
        return self._next_cursor

    @next_cursor.setter
    def next_cursor(self, next_cursor):
        """Sets the next_cursor of this MessageLogEntries.

        The next value in the database.  **Note:** If this value is not present, it means that there are no more values in the database for this combination of request parameters.   # noqa: E501

        :param next_cursor: The next_cursor of this MessageLogEntries.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                next_cursor is not None and not re.search(r'^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$', next_cursor)):  # noqa: E501
            raise ValueError(r"Invalid value for `next_cursor`, must be a follow pattern or equal to `/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/`")  # noqa: E501

        self._next_cursor = next_cursor

    @property
    def data(self):
        """Gets the data of this MessageLogEntries.  # noqa: E501

        List of message logs.  # noqa: E501

        :return: The data of this MessageLogEntries.  # noqa: E501
        :rtype: list[MessageLogEntry]
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this MessageLogEntries.

        List of message logs.  # noqa: E501

        :param data: The data of this MessageLogEntries.  # noqa: E501
        :type: list[MessageLogEntry]
        """
        if self.local_vars_configuration.client_side_validation and data is None:  # noqa: E501
            raise ValueError("Invalid value for `data`, must not be `None`")  # noqa: E501

        self._data = data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MessageLogEntries):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MessageLogEntries):
            return True

        return self.to_dict() != other.to_dict()
