# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class NewReferralsForMultipleAdvocates(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'start_date': 'datetime',
        'expiry_date': 'datetime',
        'usage_limit': 'int',
        'campaign_id': 'int',
        'advocate_profile_integration_ids': 'list[str]',
        'attributes': 'object',
        'valid_characters': 'list[str]',
        'referral_pattern': 'str'
    }

    attribute_map = {
        'start_date': 'startDate',
        'expiry_date': 'expiryDate',
        'usage_limit': 'usageLimit',
        'campaign_id': 'campaignId',
        'advocate_profile_integration_ids': 'advocateProfileIntegrationIds',
        'attributes': 'attributes',
        'valid_characters': 'validCharacters',
        'referral_pattern': 'referralPattern'
    }

    def __init__(self, start_date=None, expiry_date=None, usage_limit=None, campaign_id=None, advocate_profile_integration_ids=None, attributes=None, valid_characters=None, referral_pattern=None, local_vars_configuration=None):  # noqa: E501
        """NewReferralsForMultipleAdvocates - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._start_date = None
        self._expiry_date = None
        self._usage_limit = None
        self._campaign_id = None
        self._advocate_profile_integration_ids = None
        self._attributes = None
        self._valid_characters = None
        self._referral_pattern = None
        self.discriminator = None

        if start_date is not None:
            self.start_date = start_date
        if expiry_date is not None:
            self.expiry_date = expiry_date
        self.usage_limit = usage_limit
        self.campaign_id = campaign_id
        self.advocate_profile_integration_ids = advocate_profile_integration_ids
        if attributes is not None:
            self.attributes = attributes
        if valid_characters is not None:
            self.valid_characters = valid_characters
        if referral_pattern is not None:
            self.referral_pattern = referral_pattern

    @property
    def start_date(self):
        """Gets the start_date of this NewReferralsForMultipleAdvocates.  # noqa: E501

        Timestamp at which point the referral code becomes valid.  # noqa: E501

        :return: The start_date of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this NewReferralsForMultipleAdvocates.

        Timestamp at which point the referral code becomes valid.  # noqa: E501

        :param start_date: The start_date of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: datetime
        """

        self._start_date = start_date

    @property
    def expiry_date(self):
        """Gets the expiry_date of this NewReferralsForMultipleAdvocates.  # noqa: E501

        Expiration date of the referral code. Referral never expires if this is omitted.  # noqa: E501

        :return: The expiry_date of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: datetime
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this NewReferralsForMultipleAdvocates.

        Expiration date of the referral code. Referral never expires if this is omitted.  # noqa: E501

        :param expiry_date: The expiry_date of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: datetime
        """

        self._expiry_date = expiry_date

    @property
    def usage_limit(self):
        """Gets the usage_limit of this NewReferralsForMultipleAdvocates.  # noqa: E501

        The number of times a referral code can be used. `0` means no limit but any campaign usage limits will still apply.   # noqa: E501

        :return: The usage_limit of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: int
        """
        return self._usage_limit

    @usage_limit.setter
    def usage_limit(self, usage_limit):
        """Sets the usage_limit of this NewReferralsForMultipleAdvocates.

        The number of times a referral code can be used. `0` means no limit but any campaign usage limits will still apply.   # noqa: E501

        :param usage_limit: The usage_limit of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and usage_limit is None:  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                usage_limit is not None and usage_limit > 999999):  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must be a value less than or equal to `999999`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                usage_limit is not None and usage_limit < 0):  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must be a value greater than or equal to `0`")  # noqa: E501

        self._usage_limit = usage_limit

    @property
    def campaign_id(self):
        """Gets the campaign_id of this NewReferralsForMultipleAdvocates.  # noqa: E501

        The ID of the campaign from which the referral received the referral code.  # noqa: E501

        :return: The campaign_id of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this NewReferralsForMultipleAdvocates.

        The ID of the campaign from which the referral received the referral code.  # noqa: E501

        :param campaign_id: The campaign_id of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and campaign_id is None:  # noqa: E501
            raise ValueError("Invalid value for `campaign_id`, must not be `None`")  # noqa: E501

        self._campaign_id = campaign_id

    @property
    def advocate_profile_integration_ids(self):
        """Gets the advocate_profile_integration_ids of this NewReferralsForMultipleAdvocates.  # noqa: E501

        An array containing all the respective advocate profiles.  # noqa: E501

        :return: The advocate_profile_integration_ids of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: list[str]
        """
        return self._advocate_profile_integration_ids

    @advocate_profile_integration_ids.setter
    def advocate_profile_integration_ids(self, advocate_profile_integration_ids):
        """Sets the advocate_profile_integration_ids of this NewReferralsForMultipleAdvocates.

        An array containing all the respective advocate profiles.  # noqa: E501

        :param advocate_profile_integration_ids: The advocate_profile_integration_ids of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and advocate_profile_integration_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `advocate_profile_integration_ids`, must not be `None`")  # noqa: E501

        self._advocate_profile_integration_ids = advocate_profile_integration_ids

    @property
    def attributes(self):
        """Gets the attributes of this NewReferralsForMultipleAdvocates.  # noqa: E501

        Arbitrary properties associated with this referral code.  # noqa: E501

        :return: The attributes of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: object
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this NewReferralsForMultipleAdvocates.

        Arbitrary properties associated with this referral code.  # noqa: E501

        :param attributes: The attributes of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: object
        """

        self._attributes = attributes

    @property
    def valid_characters(self):
        """Gets the valid_characters of this NewReferralsForMultipleAdvocates.  # noqa: E501

        List of characters used to generate the random parts of a code. By default, the list of characters is equivalent to the `[A-Z, 0-9]` regular expression.   # noqa: E501

        :return: The valid_characters of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: list[str]
        """
        return self._valid_characters

    @valid_characters.setter
    def valid_characters(self, valid_characters):
        """Sets the valid_characters of this NewReferralsForMultipleAdvocates.

        List of characters used to generate the random parts of a code. By default, the list of characters is equivalent to the `[A-Z, 0-9]` regular expression.   # noqa: E501

        :param valid_characters: The valid_characters of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: list[str]
        """

        self._valid_characters = valid_characters

    @property
    def referral_pattern(self):
        """Gets the referral_pattern of this NewReferralsForMultipleAdvocates.  # noqa: E501

        The pattern used to generate referrals. The character `#` is a placeholder and is replaced by a random character from the `validCharacters` set.   # noqa: E501

        :return: The referral_pattern of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :rtype: str
        """
        return self._referral_pattern

    @referral_pattern.setter
    def referral_pattern(self, referral_pattern):
        """Sets the referral_pattern of this NewReferralsForMultipleAdvocates.

        The pattern used to generate referrals. The character `#` is a placeholder and is replaced by a random character from the `validCharacters` set.   # noqa: E501

        :param referral_pattern: The referral_pattern of this NewReferralsForMultipleAdvocates.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                referral_pattern is not None and len(referral_pattern) > 100):
            raise ValueError("Invalid value for `referral_pattern`, length must be less than or equal to `100`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                referral_pattern is not None and len(referral_pattern) < 3):
            raise ValueError("Invalid value for `referral_pattern`, length must be greater than or equal to `3`")  # noqa: E501

        self._referral_pattern = referral_pattern

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewReferralsForMultipleAdvocates):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NewReferralsForMultipleAdvocates):
            return True

        return self.to_dict() != other.to_dict()
