# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class OktaEventTarget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'str',
        'alternate_id': 'str',
        'display_name': 'str'
    }

    attribute_map = {
        'type': 'type',
        'alternate_id': 'alternateId',
        'display_name': 'displayName'
    }

    def __init__(self, type=None, alternate_id=None, display_name=None, local_vars_configuration=None):  # noqa: E501
        """OktaEventTarget - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._type = None
        self._alternate_id = None
        self._display_name = None
        self.discriminator = None

        self.type = type
        self.alternate_id = alternate_id
        self.display_name = display_name

    @property
    def type(self):
        """Gets the type of this OktaEventTarget.  # noqa: E501

        Type of the event target.  # noqa: E501

        :return: The type of this OktaEventTarget.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this OktaEventTarget.

        Type of the event target.  # noqa: E501

        :param type: The type of this OktaEventTarget.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def alternate_id(self):
        """Gets the alternate_id of this OktaEventTarget.  # noqa: E501

        Identifier of the event target, depending on its type.  # noqa: E501

        :return: The alternate_id of this OktaEventTarget.  # noqa: E501
        :rtype: str
        """
        return self._alternate_id

    @alternate_id.setter
    def alternate_id(self, alternate_id):
        """Sets the alternate_id of this OktaEventTarget.

        Identifier of the event target, depending on its type.  # noqa: E501

        :param alternate_id: The alternate_id of this OktaEventTarget.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and alternate_id is None:  # noqa: E501
            raise ValueError("Invalid value for `alternate_id`, must not be `None`")  # noqa: E501

        self._alternate_id = alternate_id

    @property
    def display_name(self):
        """Gets the display_name of this OktaEventTarget.  # noqa: E501

        Display name of the event target.  # noqa: E501

        :return: The display_name of this OktaEventTarget.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this OktaEventTarget.

        Display name of the event target.  # noqa: E501

        :param display_name: The display_name of this OktaEventTarget.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and display_name is None:  # noqa: E501
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OktaEventTarget):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OktaEventTarget):
            return True

        return self.to_dict() != other.to_dict()
