# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class OutgoingIntegrationConfiguration(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'account_id': 'int',
        'type_id': 'int',
        'policy': 'object'
    }

    attribute_map = {
        'id': 'id',
        'account_id': 'accountId',
        'type_id': 'typeId',
        'policy': 'policy'
    }

    def __init__(self, id=None, account_id=None, type_id=None, policy=None, local_vars_configuration=None):  # noqa: E501
        """OutgoingIntegrationConfiguration - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._account_id = None
        self._type_id = None
        self._policy = None
        self.discriminator = None

        self.id = id
        self.account_id = account_id
        self.type_id = type_id
        self.policy = policy

    @property
    def id(self):
        """Gets the id of this OutgoingIntegrationConfiguration.  # noqa: E501

        Unique ID for this entity.  # noqa: E501

        :return: The id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OutgoingIntegrationConfiguration.

        Unique ID for this entity.  # noqa: E501

        :param id: The id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def account_id(self):
        """Gets the account_id of this OutgoingIntegrationConfiguration.  # noqa: E501

        The ID of the account to which this configuration belongs.  # noqa: E501

        :return: The account_id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this OutgoingIntegrationConfiguration.

        The ID of the account to which this configuration belongs.  # noqa: E501

        :param account_id: The account_id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def type_id(self):
        """Gets the type_id of this OutgoingIntegrationConfiguration.  # noqa: E501

        The outgoing integration type ID.  # noqa: E501

        :return: The type_id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :rtype: int
        """
        return self._type_id

    @type_id.setter
    def type_id(self, type_id):
        """Sets the type_id of this OutgoingIntegrationConfiguration.

        The outgoing integration type ID.  # noqa: E501

        :param type_id: The type_id of this OutgoingIntegrationConfiguration.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and type_id is None:  # noqa: E501
            raise ValueError("Invalid value for `type_id`, must not be `None`")  # noqa: E501

        self._type_id = type_id

    @property
    def policy(self):
        """Gets the policy of this OutgoingIntegrationConfiguration.  # noqa: E501

        The outgoing integration policy specific to each integration type.  # noqa: E501

        :return: The policy of this OutgoingIntegrationConfiguration.  # noqa: E501
        :rtype: object
        """
        return self._policy

    @policy.setter
    def policy(self, policy):
        """Sets the policy of this OutgoingIntegrationConfiguration.

        The outgoing integration policy specific to each integration type.  # noqa: E501

        :param policy: The policy of this OutgoingIntegrationConfiguration.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and policy is None:  # noqa: E501
            raise ValueError("Invalid value for `policy`, must not be `None`")  # noqa: E501

        self._policy = policy

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OutgoingIntegrationConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OutgoingIntegrationConfiguration):
            return True

        return self.to_dict() != other.to_dict()
