# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class OutgoingIntegrationType(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'name': 'str',
        'description': 'str',
        'category': 'str',
        'documentation_link': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'description': 'description',
        'category': 'category',
        'documentation_link': 'documentationLink'
    }

    def __init__(self, id=None, name=None, description=None, category=None, documentation_link=None, local_vars_configuration=None):  # noqa: E501
        """OutgoingIntegrationType - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._description = None
        self._category = None
        self._documentation_link = None
        self.discriminator = None

        self.id = id
        self.name = name
        if description is not None:
            self.description = description
        if category is not None:
            self.category = category
        if documentation_link is not None:
            self.documentation_link = documentation_link

    @property
    def id(self):
        """Gets the id of this OutgoingIntegrationType.  # noqa: E501

        Unique ID for this entity.  # noqa: E501

        :return: The id of this OutgoingIntegrationType.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OutgoingIntegrationType.

        Unique ID for this entity.  # noqa: E501

        :param id: The id of this OutgoingIntegrationType.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this OutgoingIntegrationType.  # noqa: E501

        Name of the outgoing integration.  # noqa: E501

        :return: The name of this OutgoingIntegrationType.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this OutgoingIntegrationType.

        Name of the outgoing integration.  # noqa: E501

        :param name: The name of this OutgoingIntegrationType.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) > 64):
            raise ValueError("Invalid value for `name`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this OutgoingIntegrationType.  # noqa: E501

        Description of the outgoing integration.  # noqa: E501

        :return: The description of this OutgoingIntegrationType.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this OutgoingIntegrationType.

        Description of the outgoing integration.  # noqa: E501

        :param description: The description of this OutgoingIntegrationType.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 1000):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 1):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `1`")  # noqa: E501

        self._description = description

    @property
    def category(self):
        """Gets the category of this OutgoingIntegrationType.  # noqa: E501

        Category of the outgoing integration.  # noqa: E501

        :return: The category of this OutgoingIntegrationType.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this OutgoingIntegrationType.

        Category of the outgoing integration.  # noqa: E501

        :param category: The category of this OutgoingIntegrationType.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                category is not None and len(category) > 64):
            raise ValueError("Invalid value for `category`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                category is not None and len(category) < 1):
            raise ValueError("Invalid value for `category`, length must be greater than or equal to `1`")  # noqa: E501

        self._category = category

    @property
    def documentation_link(self):
        """Gets the documentation_link of this OutgoingIntegrationType.  # noqa: E501

        Http link to the outgoing integration's documentation.  # noqa: E501

        :return: The documentation_link of this OutgoingIntegrationType.  # noqa: E501
        :rtype: str
        """
        return self._documentation_link

    @documentation_link.setter
    def documentation_link(self, documentation_link):
        """Sets the documentation_link of this OutgoingIntegrationType.

        Http link to the outgoing integration's documentation.  # noqa: E501

        :param documentation_link: The documentation_link of this OutgoingIntegrationType.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                documentation_link is not None and len(documentation_link) > 255):
            raise ValueError("Invalid value for `documentation_link`, length must be less than or equal to `255`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                documentation_link is not None and len(documentation_link) < 1):
            raise ValueError("Invalid value for `documentation_link`, length must be greater than or equal to `1`")  # noqa: E501

        self._documentation_link = documentation_link

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OutgoingIntegrationType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OutgoingIntegrationType):
            return True

        return self.to_dict() != other.to_dict()
