# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class Picklist(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'created': 'datetime',
        'type': 'str',
        'values': 'list[str]',
        'modified_by': 'int',
        'created_by': 'int',
        'account_id': 'int',
        'imported': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'created': 'created',
        'type': 'type',
        'values': 'values',
        'modified_by': 'modifiedBy',
        'created_by': 'createdBy',
        'account_id': 'accountId',
        'imported': 'imported'
    }

    def __init__(self, id=None, created=None, type=None, values=None, modified_by=None, created_by=None, account_id=None, imported=None, local_vars_configuration=None):  # noqa: E501
        """Picklist - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created = None
        self._type = None
        self._values = None
        self._modified_by = None
        self._created_by = None
        self._account_id = None
        self._imported = None
        self.discriminator = None

        self.id = id
        self.created = created
        self.type = type
        self.values = values
        if modified_by is not None:
            self.modified_by = modified_by
        self.created_by = created_by
        if account_id is not None:
            self.account_id = account_id
        if imported is not None:
            self.imported = imported

    @property
    def id(self):
        """Gets the id of this Picklist.  # noqa: E501

        Internal ID of this entity.  # noqa: E501

        :return: The id of this Picklist.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Picklist.

        Internal ID of this entity.  # noqa: E501

        :param id: The id of this Picklist.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created(self):
        """Gets the created of this Picklist.  # noqa: E501

        The time this entity was created.  # noqa: E501

        :return: The created of this Picklist.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this Picklist.

        The time this entity was created.  # noqa: E501

        :param created: The created of this Picklist.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def type(self):
        """Gets the type of this Picklist.  # noqa: E501

        The type of allowed values in the picklist. If the type `time` is chosen, it must be an RFC3339 timestamp string.  # noqa: E501

        :return: The type of this Picklist.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Picklist.

        The type of allowed values in the picklist. If the type `time` is chosen, it must be an RFC3339 timestamp string.  # noqa: E501

        :param type: The type of this Picklist.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501
        allowed_values = ["string", "boolean", "number", "time"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def values(self):
        """Gets the values of this Picklist.  # noqa: E501

        The list of allowed values provided by this picklist.  # noqa: E501

        :return: The values of this Picklist.  # noqa: E501
        :rtype: list[str]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this Picklist.

        The list of allowed values provided by this picklist.  # noqa: E501

        :param values: The values of this Picklist.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and values is None:  # noqa: E501
            raise ValueError("Invalid value for `values`, must not be `None`")  # noqa: E501

        self._values = values

    @property
    def modified_by(self):
        """Gets the modified_by of this Picklist.  # noqa: E501

        ID of the user who last updated this effect if available.  # noqa: E501

        :return: The modified_by of this Picklist.  # noqa: E501
        :rtype: int
        """
        return self._modified_by

    @modified_by.setter
    def modified_by(self, modified_by):
        """Sets the modified_by of this Picklist.

        ID of the user who last updated this effect if available.  # noqa: E501

        :param modified_by: The modified_by of this Picklist.  # noqa: E501
        :type: int
        """

        self._modified_by = modified_by

    @property
    def created_by(self):
        """Gets the created_by of this Picklist.  # noqa: E501

        ID of the user who created this effect.  # noqa: E501

        :return: The created_by of this Picklist.  # noqa: E501
        :rtype: int
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Picklist.

        ID of the user who created this effect.  # noqa: E501

        :param created_by: The created_by of this Picklist.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and created_by is None:  # noqa: E501
            raise ValueError("Invalid value for `created_by`, must not be `None`")  # noqa: E501

        self._created_by = created_by

    @property
    def account_id(self):
        """Gets the account_id of this Picklist.  # noqa: E501

        The ID of the account that owns this entity.  # noqa: E501

        :return: The account_id of this Picklist.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this Picklist.

        The ID of the account that owns this entity.  # noqa: E501

        :param account_id: The account_id of this Picklist.  # noqa: E501
        :type: int
        """

        self._account_id = account_id

    @property
    def imported(self):
        """Gets the imported of this Picklist.  # noqa: E501

        Imported flag shows that a picklist is imported by a CSV file or not  # noqa: E501

        :return: The imported of this Picklist.  # noqa: E501
        :rtype: bool
        """
        return self._imported

    @imported.setter
    def imported(self, imported):
        """Sets the imported of this Picklist.

        Imported flag shows that a picklist is imported by a CSV file or not  # noqa: E501

        :param imported: The imported of this Picklist.  # noqa: E501
        :type: bool
        """

        self._imported = imported

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Picklist):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Picklist):
            return True

        return self.to_dict() != other.to_dict()
