# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ProjectedTier(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'projected_active_points': 'float',
        'stay_in_tier_points': 'float',
        'projected_tier_name': 'str'
    }

    attribute_map = {
        'projected_active_points': 'projectedActivePoints',
        'stay_in_tier_points': 'stayInTierPoints',
        'projected_tier_name': 'projectedTierName'
    }

    def __init__(self, projected_active_points=None, stay_in_tier_points=None, projected_tier_name=None, local_vars_configuration=None):  # noqa: E501
        """ProjectedTier - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._projected_active_points = None
        self._stay_in_tier_points = None
        self._projected_tier_name = None
        self.discriminator = None

        self.projected_active_points = projected_active_points
        if stay_in_tier_points is not None:
            self.stay_in_tier_points = stay_in_tier_points
        if projected_tier_name is not None:
            self.projected_tier_name = projected_tier_name

    @property
    def projected_active_points(self):
        """Gets the projected_active_points of this ProjectedTier.  # noqa: E501

        The active points of the customer when their current tier expires.  # noqa: E501

        :return: The projected_active_points of this ProjectedTier.  # noqa: E501
        :rtype: float
        """
        return self._projected_active_points

    @projected_active_points.setter
    def projected_active_points(self, projected_active_points):
        """Sets the projected_active_points of this ProjectedTier.

        The active points of the customer when their current tier expires.  # noqa: E501

        :param projected_active_points: The projected_active_points of this ProjectedTier.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and projected_active_points is None:  # noqa: E501
            raise ValueError("Invalid value for `projected_active_points`, must not be `None`")  # noqa: E501

        self._projected_active_points = projected_active_points

    @property
    def stay_in_tier_points(self):
        """Gets the stay_in_tier_points of this ProjectedTier.  # noqa: E501

        The number of points the customer needs to stay in the current tier.  **Note**: This is included in the response when the customer is projected to be downgraded.   # noqa: E501

        :return: The stay_in_tier_points of this ProjectedTier.  # noqa: E501
        :rtype: float
        """
        return self._stay_in_tier_points

    @stay_in_tier_points.setter
    def stay_in_tier_points(self, stay_in_tier_points):
        """Sets the stay_in_tier_points of this ProjectedTier.

        The number of points the customer needs to stay in the current tier.  **Note**: This is included in the response when the customer is projected to be downgraded.   # noqa: E501

        :param stay_in_tier_points: The stay_in_tier_points of this ProjectedTier.  # noqa: E501
        :type: float
        """

        self._stay_in_tier_points = stay_in_tier_points

    @property
    def projected_tier_name(self):
        """Gets the projected_tier_name of this ProjectedTier.  # noqa: E501

        The name of the tier the user will enter once their current tier expires.  # noqa: E501

        :return: The projected_tier_name of this ProjectedTier.  # noqa: E501
        :rtype: str
        """
        return self._projected_tier_name

    @projected_tier_name.setter
    def projected_tier_name(self, projected_tier_name):
        """Sets the projected_tier_name of this ProjectedTier.

        The name of the tier the user will enter once their current tier expires.  # noqa: E501

        :param projected_tier_name: The projected_tier_name of this ProjectedTier.  # noqa: E501
        :type: str
        """

        self._projected_tier_name = projected_tier_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectedTier):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProjectedTier):
            return True

        return self.to_dict() != other.to_dict()
