# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class Referral(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'created': 'datetime',
        'start_date': 'datetime',
        'expiry_date': 'datetime',
        'usage_limit': 'int',
        'campaign_id': 'int',
        'advocate_profile_integration_id': 'str',
        'friend_profile_integration_id': 'str',
        'attributes': 'object',
        'import_id': 'int',
        'code': 'str',
        'usage_counter': 'int',
        'batch_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'created': 'created',
        'start_date': 'startDate',
        'expiry_date': 'expiryDate',
        'usage_limit': 'usageLimit',
        'campaign_id': 'campaignId',
        'advocate_profile_integration_id': 'advocateProfileIntegrationId',
        'friend_profile_integration_id': 'friendProfileIntegrationId',
        'attributes': 'attributes',
        'import_id': 'importId',
        'code': 'code',
        'usage_counter': 'usageCounter',
        'batch_id': 'batchId'
    }

    def __init__(self, id=None, created=None, start_date=None, expiry_date=None, usage_limit=None, campaign_id=None, advocate_profile_integration_id=None, friend_profile_integration_id=None, attributes=None, import_id=None, code=None, usage_counter=None, batch_id=None, local_vars_configuration=None):  # noqa: E501
        """Referral - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created = None
        self._start_date = None
        self._expiry_date = None
        self._usage_limit = None
        self._campaign_id = None
        self._advocate_profile_integration_id = None
        self._friend_profile_integration_id = None
        self._attributes = None
        self._import_id = None
        self._code = None
        self._usage_counter = None
        self._batch_id = None
        self.discriminator = None

        self.id = id
        self.created = created
        if start_date is not None:
            self.start_date = start_date
        if expiry_date is not None:
            self.expiry_date = expiry_date
        self.usage_limit = usage_limit
        self.campaign_id = campaign_id
        self.advocate_profile_integration_id = advocate_profile_integration_id
        if friend_profile_integration_id is not None:
            self.friend_profile_integration_id = friend_profile_integration_id
        if attributes is not None:
            self.attributes = attributes
        if import_id is not None:
            self.import_id = import_id
        self.code = code
        self.usage_counter = usage_counter
        if batch_id is not None:
            self.batch_id = batch_id

    @property
    def id(self):
        """Gets the id of this Referral.  # noqa: E501

        Internal ID of this entity.  # noqa: E501

        :return: The id of this Referral.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Referral.

        Internal ID of this entity.  # noqa: E501

        :param id: The id of this Referral.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created(self):
        """Gets the created of this Referral.  # noqa: E501

        The time this entity was created.  # noqa: E501

        :return: The created of this Referral.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this Referral.

        The time this entity was created.  # noqa: E501

        :param created: The created of this Referral.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def start_date(self):
        """Gets the start_date of this Referral.  # noqa: E501

        Timestamp at which point the referral code becomes valid.  # noqa: E501

        :return: The start_date of this Referral.  # noqa: E501
        :rtype: datetime
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this Referral.

        Timestamp at which point the referral code becomes valid.  # noqa: E501

        :param start_date: The start_date of this Referral.  # noqa: E501
        :type: datetime
        """

        self._start_date = start_date

    @property
    def expiry_date(self):
        """Gets the expiry_date of this Referral.  # noqa: E501

        Expiration date of the referral code. Referral never expires if this is omitted.  # noqa: E501

        :return: The expiry_date of this Referral.  # noqa: E501
        :rtype: datetime
        """
        return self._expiry_date

    @expiry_date.setter
    def expiry_date(self, expiry_date):
        """Sets the expiry_date of this Referral.

        Expiration date of the referral code. Referral never expires if this is omitted.  # noqa: E501

        :param expiry_date: The expiry_date of this Referral.  # noqa: E501
        :type: datetime
        """

        self._expiry_date = expiry_date

    @property
    def usage_limit(self):
        """Gets the usage_limit of this Referral.  # noqa: E501

        The number of times a referral code can be used. `0` means no limit but any campaign usage limits will still apply.   # noqa: E501

        :return: The usage_limit of this Referral.  # noqa: E501
        :rtype: int
        """
        return self._usage_limit

    @usage_limit.setter
    def usage_limit(self, usage_limit):
        """Sets the usage_limit of this Referral.

        The number of times a referral code can be used. `0` means no limit but any campaign usage limits will still apply.   # noqa: E501

        :param usage_limit: The usage_limit of this Referral.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and usage_limit is None:  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                usage_limit is not None and usage_limit > 999999):  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must be a value less than or equal to `999999`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                usage_limit is not None and usage_limit < 0):  # noqa: E501
            raise ValueError("Invalid value for `usage_limit`, must be a value greater than or equal to `0`")  # noqa: E501

        self._usage_limit = usage_limit

    @property
    def campaign_id(self):
        """Gets the campaign_id of this Referral.  # noqa: E501

        ID of the campaign from which the referral received the referral code.  # noqa: E501

        :return: The campaign_id of this Referral.  # noqa: E501
        :rtype: int
        """
        return self._campaign_id

    @campaign_id.setter
    def campaign_id(self, campaign_id):
        """Sets the campaign_id of this Referral.

        ID of the campaign from which the referral received the referral code.  # noqa: E501

        :param campaign_id: The campaign_id of this Referral.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and campaign_id is None:  # noqa: E501
            raise ValueError("Invalid value for `campaign_id`, must not be `None`")  # noqa: E501

        self._campaign_id = campaign_id

    @property
    def advocate_profile_integration_id(self):
        """Gets the advocate_profile_integration_id of this Referral.  # noqa: E501

        The Integration ID of the Advocate's Profile.  # noqa: E501

        :return: The advocate_profile_integration_id of this Referral.  # noqa: E501
        :rtype: str
        """
        return self._advocate_profile_integration_id

    @advocate_profile_integration_id.setter
    def advocate_profile_integration_id(self, advocate_profile_integration_id):
        """Sets the advocate_profile_integration_id of this Referral.

        The Integration ID of the Advocate's Profile.  # noqa: E501

        :param advocate_profile_integration_id: The advocate_profile_integration_id of this Referral.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and advocate_profile_integration_id is None:  # noqa: E501
            raise ValueError("Invalid value for `advocate_profile_integration_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                advocate_profile_integration_id is not None and len(advocate_profile_integration_id) > 1000):
            raise ValueError("Invalid value for `advocate_profile_integration_id`, length must be less than or equal to `1000`")  # noqa: E501

        self._advocate_profile_integration_id = advocate_profile_integration_id

    @property
    def friend_profile_integration_id(self):
        """Gets the friend_profile_integration_id of this Referral.  # noqa: E501

        An optional Integration ID of the Friend's Profile.  # noqa: E501

        :return: The friend_profile_integration_id of this Referral.  # noqa: E501
        :rtype: str
        """
        return self._friend_profile_integration_id

    @friend_profile_integration_id.setter
    def friend_profile_integration_id(self, friend_profile_integration_id):
        """Sets the friend_profile_integration_id of this Referral.

        An optional Integration ID of the Friend's Profile.  # noqa: E501

        :param friend_profile_integration_id: The friend_profile_integration_id of this Referral.  # noqa: E501
        :type: str
        """

        self._friend_profile_integration_id = friend_profile_integration_id

    @property
    def attributes(self):
        """Gets the attributes of this Referral.  # noqa: E501

        Arbitrary properties associated with this item.  # noqa: E501

        :return: The attributes of this Referral.  # noqa: E501
        :rtype: object
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this Referral.

        Arbitrary properties associated with this item.  # noqa: E501

        :param attributes: The attributes of this Referral.  # noqa: E501
        :type: object
        """

        self._attributes = attributes

    @property
    def import_id(self):
        """Gets the import_id of this Referral.  # noqa: E501

        The ID of the Import which created this referral.  # noqa: E501

        :return: The import_id of this Referral.  # noqa: E501
        :rtype: int
        """
        return self._import_id

    @import_id.setter
    def import_id(self, import_id):
        """Sets the import_id of this Referral.

        The ID of the Import which created this referral.  # noqa: E501

        :param import_id: The import_id of this Referral.  # noqa: E501
        :type: int
        """

        self._import_id = import_id

    @property
    def code(self):
        """Gets the code of this Referral.  # noqa: E501

        The referral code.  # noqa: E501

        :return: The code of this Referral.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this Referral.

        The referral code.  # noqa: E501

        :param code: The code of this Referral.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and code is None:  # noqa: E501
            raise ValueError("Invalid value for `code`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and len(code) < 4):
            raise ValueError("Invalid value for `code`, length must be greater than or equal to `4`")  # noqa: E501

        self._code = code

    @property
    def usage_counter(self):
        """Gets the usage_counter of this Referral.  # noqa: E501

        The number of times this referral code has been successfully used.  # noqa: E501

        :return: The usage_counter of this Referral.  # noqa: E501
        :rtype: int
        """
        return self._usage_counter

    @usage_counter.setter
    def usage_counter(self, usage_counter):
        """Sets the usage_counter of this Referral.

        The number of times this referral code has been successfully used.  # noqa: E501

        :param usage_counter: The usage_counter of this Referral.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and usage_counter is None:  # noqa: E501
            raise ValueError("Invalid value for `usage_counter`, must not be `None`")  # noqa: E501

        self._usage_counter = usage_counter

    @property
    def batch_id(self):
        """Gets the batch_id of this Referral.  # noqa: E501

        The ID of the batch the referrals belong to.  # noqa: E501

        :return: The batch_id of this Referral.  # noqa: E501
        :rtype: str
        """
        return self._batch_id

    @batch_id.setter
    def batch_id(self, batch_id):
        """Sets the batch_id of this Referral.

        The ID of the batch the referrals belong to.  # noqa: E501

        :param batch_id: The batch_id of this Referral.  # noqa: E501
        :type: str
        """

        self._batch_id = batch_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Referral):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Referral):
            return True

        return self.to_dict() != other.to_dict()
