# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ReserveCouponEffectProps(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'coupon_value': 'str',
        'profile_integration_id': 'str',
        'is_new_reservation': 'bool'
    }

    attribute_map = {
        'coupon_value': 'couponValue',
        'profile_integration_id': 'profileIntegrationId',
        'is_new_reservation': 'isNewReservation'
    }

    def __init__(self, coupon_value=None, profile_integration_id=None, is_new_reservation=None, local_vars_configuration=None):  # noqa: E501
        """ReserveCouponEffectProps - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._coupon_value = None
        self._profile_integration_id = None
        self._is_new_reservation = None
        self.discriminator = None

        self.coupon_value = coupon_value
        self.profile_integration_id = profile_integration_id
        self.is_new_reservation = is_new_reservation

    @property
    def coupon_value(self):
        """Gets the coupon_value of this ReserveCouponEffectProps.  # noqa: E501

        The value of the coupon currently on scope.  # noqa: E501

        :return: The coupon_value of this ReserveCouponEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._coupon_value

    @coupon_value.setter
    def coupon_value(self, coupon_value):
        """Sets the coupon_value of this ReserveCouponEffectProps.

        The value of the coupon currently on scope.  # noqa: E501

        :param coupon_value: The coupon_value of this ReserveCouponEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and coupon_value is None:  # noqa: E501
            raise ValueError("Invalid value for `coupon_value`, must not be `None`")  # noqa: E501

        self._coupon_value = coupon_value

    @property
    def profile_integration_id(self):
        """Gets the profile_integration_id of this ReserveCouponEffectProps.  # noqa: E501

        The ID of this customer profile in the third-party integration.  # noqa: E501

        :return: The profile_integration_id of this ReserveCouponEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._profile_integration_id

    @profile_integration_id.setter
    def profile_integration_id(self, profile_integration_id):
        """Sets the profile_integration_id of this ReserveCouponEffectProps.

        The ID of this customer profile in the third-party integration.  # noqa: E501

        :param profile_integration_id: The profile_integration_id of this ReserveCouponEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and profile_integration_id is None:  # noqa: E501
            raise ValueError("Invalid value for `profile_integration_id`, must not be `None`")  # noqa: E501

        self._profile_integration_id = profile_integration_id

    @property
    def is_new_reservation(self):
        """Gets the is_new_reservation of this ReserveCouponEffectProps.  # noqa: E501

        Indicates whether this is a new coupon reservation or not.  # noqa: E501

        :return: The is_new_reservation of this ReserveCouponEffectProps.  # noqa: E501
        :rtype: bool
        """
        return self._is_new_reservation

    @is_new_reservation.setter
    def is_new_reservation(self, is_new_reservation):
        """Sets the is_new_reservation of this ReserveCouponEffectProps.

        Indicates whether this is a new coupon reservation or not.  # noqa: E501

        :param is_new_reservation: The is_new_reservation of this ReserveCouponEffectProps.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and is_new_reservation is None:  # noqa: E501
            raise ValueError("Invalid value for `is_new_reservation`, must not be `None`")  # noqa: E501

        self._is_new_reservation = is_new_reservation

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ReserveCouponEffectProps):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ReserveCouponEffectProps):
            return True

        return self.to_dict() != other.to_dict()
