# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class RoleV2(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'int',
        'created': 'datetime',
        'modified': 'datetime',
        'account_id': 'int',
        'name': 'str',
        'description': 'str',
        'permissions': 'RoleV2Permissions',
        'members': 'list[int]'
    }

    attribute_map = {
        'id': 'id',
        'created': 'created',
        'modified': 'modified',
        'account_id': 'accountId',
        'name': 'name',
        'description': 'description',
        'permissions': 'permissions',
        'members': 'members'
    }

    def __init__(self, id=None, created=None, modified=None, account_id=None, name=None, description=None, permissions=None, members=None, local_vars_configuration=None):  # noqa: E501
        """RoleV2 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created = None
        self._modified = None
        self._account_id = None
        self._name = None
        self._description = None
        self._permissions = None
        self._members = None
        self.discriminator = None

        self.id = id
        self.created = created
        self.modified = modified
        self.account_id = account_id
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if permissions is not None:
            self.permissions = permissions
        if members is not None:
            self.members = members

    @property
    def id(self):
        """Gets the id of this RoleV2.  # noqa: E501

        Internal ID of this entity.  # noqa: E501

        :return: The id of this RoleV2.  # noqa: E501
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this RoleV2.

        Internal ID of this entity.  # noqa: E501

        :param id: The id of this RoleV2.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created(self):
        """Gets the created of this RoleV2.  # noqa: E501

        The time this entity was created.  # noqa: E501

        :return: The created of this RoleV2.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this RoleV2.

        The time this entity was created.  # noqa: E501

        :param created: The created of this RoleV2.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created is None:  # noqa: E501
            raise ValueError("Invalid value for `created`, must not be `None`")  # noqa: E501

        self._created = created

    @property
    def modified(self):
        """Gets the modified of this RoleV2.  # noqa: E501

        The time this entity was last modified.  # noqa: E501

        :return: The modified of this RoleV2.  # noqa: E501
        :rtype: datetime
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this RoleV2.

        The time this entity was last modified.  # noqa: E501

        :param modified: The modified of this RoleV2.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and modified is None:  # noqa: E501
            raise ValueError("Invalid value for `modified`, must not be `None`")  # noqa: E501

        self._modified = modified

    @property
    def account_id(self):
        """Gets the account_id of this RoleV2.  # noqa: E501

        The ID of the account that owns this entity.  # noqa: E501

        :return: The account_id of this RoleV2.  # noqa: E501
        :rtype: int
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this RoleV2.

        The ID of the account that owns this entity.  # noqa: E501

        :param account_id: The account_id of this RoleV2.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def name(self):
        """Gets the name of this RoleV2.  # noqa: E501

        Name of the role.  # noqa: E501

        :return: The name of this RoleV2.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RoleV2.

        Name of the role.  # noqa: E501

        :param name: The name of this RoleV2.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this RoleV2.  # noqa: E501

        Description of the role.  # noqa: E501

        :return: The description of this RoleV2.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RoleV2.

        Description of the role.  # noqa: E501

        :param description: The description of this RoleV2.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def permissions(self):
        """Gets the permissions of this RoleV2.  # noqa: E501


        :return: The permissions of this RoleV2.  # noqa: E501
        :rtype: RoleV2Permissions
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this RoleV2.


        :param permissions: The permissions of this RoleV2.  # noqa: E501
        :type: RoleV2Permissions
        """

        self._permissions = permissions

    @property
    def members(self):
        """Gets the members of this RoleV2.  # noqa: E501

        A list of user IDs the role is assigned to.  # noqa: E501

        :return: The members of this RoleV2.  # noqa: E501
        :rtype: list[int]
        """
        return self._members

    @members.setter
    def members(self, members):
        """Sets the members of this RoleV2.

        A list of user IDs the role is assigned to.  # noqa: E501

        :param members: The members of this RoleV2.  # noqa: E501
        :type: list[int]
        """

        self._members = members

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleV2):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RoleV2):
            return True

        return self.to_dict() != other.to_dict()
