# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class RoleV2ApplicationDetails(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'application': 'str',
        'campaign': 'str',
        'draft_campaign': 'str',
        'tools': 'str'
    }

    attribute_map = {
        'application': 'application',
        'campaign': 'campaign',
        'draft_campaign': 'draftCampaign',
        'tools': 'tools'
    }

    def __init__(self, application=None, campaign=None, draft_campaign=None, tools=None, local_vars_configuration=None):  # noqa: E501
        """RoleV2ApplicationDetails - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._application = None
        self._campaign = None
        self._draft_campaign = None
        self._tools = None
        self.discriminator = None

        if application is not None:
            self.application = application
        if campaign is not None:
            self.campaign = campaign
        if draft_campaign is not None:
            self.draft_campaign = draft_campaign
        if tools is not None:
            self.tools = tools

    @property
    def application(self):
        """Gets the application of this RoleV2ApplicationDetails.  # noqa: E501

        Name of the Application-related permission set for the given Application.  # noqa: E501

        :return: The application of this RoleV2ApplicationDetails.  # noqa: E501
        :rtype: str
        """
        return self._application

    @application.setter
    def application(self, application):
        """Sets the application of this RoleV2ApplicationDetails.

        Name of the Application-related permission set for the given Application.  # noqa: E501

        :param application: The application of this RoleV2ApplicationDetails.  # noqa: E501
        :type: str
        """

        self._application = application

    @property
    def campaign(self):
        """Gets the campaign of this RoleV2ApplicationDetails.  # noqa: E501

        Name of the campaign-related permission set for the given Application.  # noqa: E501

        :return: The campaign of this RoleV2ApplicationDetails.  # noqa: E501
        :rtype: str
        """
        return self._campaign

    @campaign.setter
    def campaign(self, campaign):
        """Sets the campaign of this RoleV2ApplicationDetails.

        Name of the campaign-related permission set for the given Application.  # noqa: E501

        :param campaign: The campaign of this RoleV2ApplicationDetails.  # noqa: E501
        :type: str
        """

        self._campaign = campaign

    @property
    def draft_campaign(self):
        """Gets the draft_campaign of this RoleV2ApplicationDetails.  # noqa: E501

        Name of the draft campaign-related permission set for the given Application.  # noqa: E501

        :return: The draft_campaign of this RoleV2ApplicationDetails.  # noqa: E501
        :rtype: str
        """
        return self._draft_campaign

    @draft_campaign.setter
    def draft_campaign(self, draft_campaign):
        """Sets the draft_campaign of this RoleV2ApplicationDetails.

        Name of the draft campaign-related permission set for the given Application.  # noqa: E501

        :param draft_campaign: The draft_campaign of this RoleV2ApplicationDetails.  # noqa: E501
        :type: str
        """

        self._draft_campaign = draft_campaign

    @property
    def tools(self):
        """Gets the tools of this RoleV2ApplicationDetails.  # noqa: E501

        Name of the tools-related permission set.  # noqa: E501

        :return: The tools of this RoleV2ApplicationDetails.  # noqa: E501
        :rtype: str
        """
        return self._tools

    @tools.setter
    def tools(self, tools):
        """Sets the tools of this RoleV2ApplicationDetails.

        Name of the tools-related permission set.  # noqa: E501

        :param tools: The tools of this RoleV2ApplicationDetails.  # noqa: E501
        :type: str
        """

        self._tools = tools

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleV2ApplicationDetails):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RoleV2ApplicationDetails):
            return True

        return self.to_dict() != other.to_dict()
