# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class RoleV2Permissions(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'permission_sets': 'list[RoleV2PermissionSet]',
        'roles': 'RoleV2RolesGroup'
    }

    attribute_map = {
        'permission_sets': 'permissionSets',
        'roles': 'roles'
    }

    def __init__(self, permission_sets=None, roles=None, local_vars_configuration=None):  # noqa: E501
        """RoleV2Permissions - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._permission_sets = None
        self._roles = None
        self.discriminator = None

        if permission_sets is not None:
            self.permission_sets = permission_sets
        if roles is not None:
            self.roles = roles

    @property
    def permission_sets(self):
        """Gets the permission_sets of this RoleV2Permissions.  # noqa: E501

        List of grouped logical operations referenced by roles.  # noqa: E501

        :return: The permission_sets of this RoleV2Permissions.  # noqa: E501
        :rtype: list[RoleV2PermissionSet]
        """
        return self._permission_sets

    @permission_sets.setter
    def permission_sets(self, permission_sets):
        """Sets the permission_sets of this RoleV2Permissions.

        List of grouped logical operations referenced by roles.  # noqa: E501

        :param permission_sets: The permission_sets of this RoleV2Permissions.  # noqa: E501
        :type: list[RoleV2PermissionSet]
        """

        self._permission_sets = permission_sets

    @property
    def roles(self):
        """Gets the roles of this RoleV2Permissions.  # noqa: E501


        :return: The roles of this RoleV2Permissions.  # noqa: E501
        :rtype: RoleV2RolesGroup
        """
        return self._roles

    @roles.setter
    def roles(self, roles):
        """Sets the roles of this RoleV2Permissions.


        :param roles: The roles of this RoleV2Permissions.  # noqa: E501
        :type: RoleV2RolesGroup
        """

        self._roles = roles

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleV2Permissions):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RoleV2Permissions):
            return True

        return self.to_dict() != other.to_dict()
