# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class RollbackDiscountEffectProps(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'value': 'float',
        'cart_item_position': 'float',
        'cart_item_sub_position': 'float',
        'additional_cost_id': 'int',
        'additional_cost': 'str',
        'scope': 'str'
    }

    attribute_map = {
        'name': 'name',
        'value': 'value',
        'cart_item_position': 'cartItemPosition',
        'cart_item_sub_position': 'cartItemSubPosition',
        'additional_cost_id': 'additionalCostId',
        'additional_cost': 'additionalCost',
        'scope': 'scope'
    }

    def __init__(self, name=None, value=None, cart_item_position=None, cart_item_sub_position=None, additional_cost_id=None, additional_cost=None, scope=None, local_vars_configuration=None):  # noqa: E501
        """RollbackDiscountEffectProps - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._value = None
        self._cart_item_position = None
        self._cart_item_sub_position = None
        self._additional_cost_id = None
        self._additional_cost = None
        self._scope = None
        self.discriminator = None

        self.name = name
        self.value = value
        if cart_item_position is not None:
            self.cart_item_position = cart_item_position
        if cart_item_sub_position is not None:
            self.cart_item_sub_position = cart_item_sub_position
        if additional_cost_id is not None:
            self.additional_cost_id = additional_cost_id
        if additional_cost is not None:
            self.additional_cost = additional_cost
        if scope is not None:
            self.scope = scope

    @property
    def name(self):
        """Gets the name of this RollbackDiscountEffectProps.  # noqa: E501

        The name of the \"setDiscount\" effect that was rolled back.  # noqa: E501

        :return: The name of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RollbackDiscountEffectProps.

        The name of the \"setDiscount\" effect that was rolled back.  # noqa: E501

        :param name: The name of this RollbackDiscountEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def value(self):
        """Gets the value of this RollbackDiscountEffectProps.  # noqa: E501

        The value of the discount that was rolled back.  # noqa: E501

        :return: The value of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: float
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this RollbackDiscountEffectProps.

        The value of the discount that was rolled back.  # noqa: E501

        :param value: The value of this RollbackDiscountEffectProps.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and value is None:  # noqa: E501
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def cart_item_position(self):
        """Gets the cart_item_position of this RollbackDiscountEffectProps.  # noqa: E501

        The index of the item in the cart items for which the discount was rolled back.  # noqa: E501

        :return: The cart_item_position of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: float
        """
        return self._cart_item_position

    @cart_item_position.setter
    def cart_item_position(self, cart_item_position):
        """Sets the cart_item_position of this RollbackDiscountEffectProps.

        The index of the item in the cart items for which the discount was rolled back.  # noqa: E501

        :param cart_item_position: The cart_item_position of this RollbackDiscountEffectProps.  # noqa: E501
        :type: float
        """

        self._cart_item_position = cart_item_position

    @property
    def cart_item_sub_position(self):
        """Gets the cart_item_sub_position of this RollbackDiscountEffectProps.  # noqa: E501

        For cart items with `quantity` > 1, the subposition returns the index of the item unit in its line item.   # noqa: E501

        :return: The cart_item_sub_position of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: float
        """
        return self._cart_item_sub_position

    @cart_item_sub_position.setter
    def cart_item_sub_position(self, cart_item_sub_position):
        """Sets the cart_item_sub_position of this RollbackDiscountEffectProps.

        For cart items with `quantity` > 1, the subposition returns the index of the item unit in its line item.   # noqa: E501

        :param cart_item_sub_position: The cart_item_sub_position of this RollbackDiscountEffectProps.  # noqa: E501
        :type: float
        """

        self._cart_item_sub_position = cart_item_sub_position

    @property
    def additional_cost_id(self):
        """Gets the additional_cost_id of this RollbackDiscountEffectProps.  # noqa: E501

        The ID of the additional cost that was rolled back.  # noqa: E501

        :return: The additional_cost_id of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: int
        """
        return self._additional_cost_id

    @additional_cost_id.setter
    def additional_cost_id(self, additional_cost_id):
        """Sets the additional_cost_id of this RollbackDiscountEffectProps.

        The ID of the additional cost that was rolled back.  # noqa: E501

        :param additional_cost_id: The additional_cost_id of this RollbackDiscountEffectProps.  # noqa: E501
        :type: int
        """

        self._additional_cost_id = additional_cost_id

    @property
    def additional_cost(self):
        """Gets the additional_cost of this RollbackDiscountEffectProps.  # noqa: E501

        The name of the additional cost that was rolled back.  # noqa: E501

        :return: The additional_cost of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._additional_cost

    @additional_cost.setter
    def additional_cost(self, additional_cost):
        """Sets the additional_cost of this RollbackDiscountEffectProps.

        The name of the additional cost that was rolled back.  # noqa: E501

        :param additional_cost: The additional_cost of this RollbackDiscountEffectProps.  # noqa: E501
        :type: str
        """

        self._additional_cost = additional_cost

    @property
    def scope(self):
        """Gets the scope of this RollbackDiscountEffectProps.  # noqa: E501

        The scope of the rolled back discount - For a discount per session, it can be one of `cartItems`, `additionalCosts` or `sessionTotal` - For a discount per item, it can be one of `price`, `additionalCosts` or `itemTotal`   # noqa: E501

        :return: The scope of this RollbackDiscountEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._scope

    @scope.setter
    def scope(self, scope):
        """Sets the scope of this RollbackDiscountEffectProps.

        The scope of the rolled back discount - For a discount per session, it can be one of `cartItems`, `additionalCosts` or `sessionTotal` - For a discount per item, it can be one of `price`, `additionalCosts` or `itemTotal`   # noqa: E501

        :param scope: The scope of this RollbackDiscountEffectProps.  # noqa: E501
        :type: str
        """

        self._scope = scope

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RollbackDiscountEffectProps):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RollbackDiscountEffectProps):
            return True

        return self.to_dict() != other.to_dict()
