# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class SamlConnectionMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'enabled': 'bool',
        'account_id': 'float',
        'metadata_document': 'str'
    }

    attribute_map = {
        'name': 'name',
        'enabled': 'enabled',
        'account_id': 'accountId',
        'metadata_document': 'metadataDocument'
    }

    def __init__(self, name=None, enabled=None, account_id=None, metadata_document=None, local_vars_configuration=None):  # noqa: E501
        """SamlConnectionMetadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._enabled = None
        self._account_id = None
        self._metadata_document = None
        self.discriminator = None

        self.name = name
        self.enabled = enabled
        self.account_id = account_id
        self.metadata_document = metadata_document

    @property
    def name(self):
        """Gets the name of this SamlConnectionMetadata.  # noqa: E501

        ID of the SAML service.  # noqa: E501

        :return: The name of this SamlConnectionMetadata.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SamlConnectionMetadata.

        ID of the SAML service.  # noqa: E501

        :param name: The name of this SamlConnectionMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                name is not None and len(name) < 1):
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")  # noqa: E501

        self._name = name

    @property
    def enabled(self):
        """Gets the enabled of this SamlConnectionMetadata.  # noqa: E501

        Determines if this SAML connection active.  # noqa: E501

        :return: The enabled of this SamlConnectionMetadata.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this SamlConnectionMetadata.

        Determines if this SAML connection active.  # noqa: E501

        :param enabled: The enabled of this SamlConnectionMetadata.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and enabled is None:  # noqa: E501
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def account_id(self):
        """Gets the account_id of this SamlConnectionMetadata.  # noqa: E501


        :return: The account_id of this SamlConnectionMetadata.  # noqa: E501
        :rtype: float
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this SamlConnectionMetadata.


        :param account_id: The account_id of this SamlConnectionMetadata.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def metadata_document(self):
        """Gets the metadata_document of this SamlConnectionMetadata.  # noqa: E501

        Identity Provider metadata XML document.  # noqa: E501

        :return: The metadata_document of this SamlConnectionMetadata.  # noqa: E501
        :rtype: str
        """
        return self._metadata_document

    @metadata_document.setter
    def metadata_document(self, metadata_document):
        """Sets the metadata_document of this SamlConnectionMetadata.

        Identity Provider metadata XML document.  # noqa: E501

        :param metadata_document: The metadata_document of this SamlConnectionMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and metadata_document is None:  # noqa: E501
            raise ValueError("Invalid value for `metadata_document`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                metadata_document is not None and len(metadata_document) < 1):
            raise ValueError("Invalid value for `metadata_document`, length must be greater than or equal to `1`")  # noqa: E501

        self._metadata_document = metadata_document

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SamlConnectionMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SamlConnectionMetadata):
            return True

        return self.to_dict() != other.to_dict()
