# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ScimPatchRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'schemas': 'list[str]',
        'operations': 'list[ScimPatchOperation]'
    }

    attribute_map = {
        'schemas': 'schemas',
        'operations': 'Operations'
    }

    def __init__(self, schemas=None, operations=None, local_vars_configuration=None):  # noqa: E501
        """ScimPatchRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._schemas = None
        self._operations = None
        self.discriminator = None

        if schemas is not None:
            self.schemas = schemas
        self.operations = operations

    @property
    def schemas(self):
        """Gets the schemas of this ScimPatchRequest.  # noqa: E501

        SCIM schema for the given resource.  # noqa: E501

        :return: The schemas of this ScimPatchRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._schemas

    @schemas.setter
    def schemas(self, schemas):
        """Sets the schemas of this ScimPatchRequest.

        SCIM schema for the given resource.  # noqa: E501

        :param schemas: The schemas of this ScimPatchRequest.  # noqa: E501
        :type: list[str]
        """

        self._schemas = schemas

    @property
    def operations(self):
        """Gets the operations of this ScimPatchRequest.  # noqa: E501


        :return: The operations of this ScimPatchRequest.  # noqa: E501
        :rtype: list[ScimPatchOperation]
        """
        return self._operations

    @operations.setter
    def operations(self, operations):
        """Sets the operations of this ScimPatchRequest.


        :param operations: The operations of this ScimPatchRequest.  # noqa: E501
        :type: list[ScimPatchOperation]
        """
        if self.local_vars_configuration.client_side_validation and operations is None:  # noqa: E501
            raise ValueError("Invalid value for `operations`, must not be `None`")  # noqa: E501

        self._operations = operations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ScimPatchRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ScimPatchRequest):
            return True

        return self.to_dict() != other.to_dict()
