# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class ShowBundleMetadataEffectProps(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'description': 'str',
        'bundle_attributes': 'list[str]',
        'items_indices': 'list[float]'
    }

    attribute_map = {
        'description': 'description',
        'bundle_attributes': 'bundleAttributes',
        'items_indices': 'itemsIndices'
    }

    def __init__(self, description=None, bundle_attributes=None, items_indices=None, local_vars_configuration=None):  # noqa: E501
        """ShowBundleMetadataEffectProps - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._description = None
        self._bundle_attributes = None
        self._items_indices = None
        self.discriminator = None

        self.description = description
        self.bundle_attributes = bundle_attributes
        self.items_indices = items_indices

    @property
    def description(self):
        """Gets the description of this ShowBundleMetadataEffectProps.  # noqa: E501

        Description of the product bundle.  # noqa: E501

        :return: The description of this ShowBundleMetadataEffectProps.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ShowBundleMetadataEffectProps.

        Description of the product bundle.  # noqa: E501

        :param description: The description of this ShowBundleMetadataEffectProps.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def bundle_attributes(self):
        """Gets the bundle_attributes of this ShowBundleMetadataEffectProps.  # noqa: E501

        The cart item attributes that determined which items are being bundled together.  # noqa: E501

        :return: The bundle_attributes of this ShowBundleMetadataEffectProps.  # noqa: E501
        :rtype: list[str]
        """
        return self._bundle_attributes

    @bundle_attributes.setter
    def bundle_attributes(self, bundle_attributes):
        """Sets the bundle_attributes of this ShowBundleMetadataEffectProps.

        The cart item attributes that determined which items are being bundled together.  # noqa: E501

        :param bundle_attributes: The bundle_attributes of this ShowBundleMetadataEffectProps.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and bundle_attributes is None:  # noqa: E501
            raise ValueError("Invalid value for `bundle_attributes`, must not be `None`")  # noqa: E501

        self._bundle_attributes = bundle_attributes

    @property
    def items_indices(self):
        """Gets the items_indices of this ShowBundleMetadataEffectProps.  # noqa: E501

        The indices in the cart items array of the bundled items.  # noqa: E501

        :return: The items_indices of this ShowBundleMetadataEffectProps.  # noqa: E501
        :rtype: list[float]
        """
        return self._items_indices

    @items_indices.setter
    def items_indices(self, items_indices):
        """Sets the items_indices of this ShowBundleMetadataEffectProps.

        The indices in the cart items array of the bundled items.  # noqa: E501

        :param items_indices: The items_indices of this ShowBundleMetadataEffectProps.  # noqa: E501
        :type: list[float]
        """
        if self.local_vars_configuration.client_side_validation and items_indices is None:  # noqa: E501
            raise ValueError("Invalid value for `items_indices`, must not be `None`")  # noqa: E501

        self._items_indices = items_indices

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ShowBundleMetadataEffectProps):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ShowBundleMetadataEffectProps):
            return True

        return self.to_dict() != other.to_dict()
