# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class SlotDef(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'type': 'str',
        'title': 'str',
        'description': 'str',
        'help': 'str',
        'writable': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'type': 'type',
        'title': 'title',
        'description': 'description',
        'help': 'help',
        'writable': 'writable'
    }

    def __init__(self, name=None, type=None, title=None, description=None, help=None, writable=None, local_vars_configuration=None):  # noqa: E501
        """SlotDef - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._type = None
        self._title = None
        self._description = None
        self._help = None
        self._writable = None
        self.discriminator = None

        self.name = name
        self.type = type
        self.title = title
        if description is not None:
            self.description = description
        if help is not None:
            self.help = help
        self.writable = writable

    @property
    def name(self):
        """Gets the name of this SlotDef.  # noqa: E501

        The dot-separated path to this slot for use in Talang.  # noqa: E501

        :return: The name of this SlotDef.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SlotDef.

        The dot-separated path to this slot for use in Talang.  # noqa: E501

        :param name: The name of this SlotDef.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def type(self):
        """Gets the type of this SlotDef.  # noqa: E501

        The type of this slot, one of string, number, boolean, or list[type].  # noqa: E501

        :return: The type of this SlotDef.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this SlotDef.

        The type of this slot, one of string, number, boolean, or list[type].  # noqa: E501

        :param type: The type of this SlotDef.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def title(self):
        """Gets the title of this SlotDef.  # noqa: E501

        Campaigner-friendly name for the slot.  # noqa: E501

        :return: The title of this SlotDef.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this SlotDef.

        Campaigner-friendly name for the slot.  # noqa: E501

        :param title: The title of this SlotDef.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and title is None:  # noqa: E501
            raise ValueError("Invalid value for `title`, must not be `None`")  # noqa: E501

        self._title = title

    @property
    def description(self):
        """Gets the description of this SlotDef.  # noqa: E501

        A short description of the slot.  # noqa: E501

        :return: The description of this SlotDef.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this SlotDef.

        A short description of the slot.  # noqa: E501

        :param description: The description of this SlotDef.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def help(self):
        """Gets the help of this SlotDef.  # noqa: E501

        Extended help text for the slot.  # noqa: E501

        :return: The help of this SlotDef.  # noqa: E501
        :rtype: str
        """
        return self._help

    @help.setter
    def help(self, help):
        """Sets the help of this SlotDef.

        Extended help text for the slot.  # noqa: E501

        :param help: The help of this SlotDef.  # noqa: E501
        :type: str
        """

        self._help = help

    @property
    def writable(self):
        """Gets the writable of this SlotDef.  # noqa: E501

        Whether or not this slot can be updated by rule effects.  # noqa: E501

        :return: The writable of this SlotDef.  # noqa: E501
        :rtype: bool
        """
        return self._writable

    @writable.setter
    def writable(self, writable):
        """Sets the writable of this SlotDef.

        Whether or not this slot can be updated by rule effects.  # noqa: E501

        :param writable: The writable of this SlotDef.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and writable is None:  # noqa: E501
            raise ValueError("Invalid value for `writable`, must not be `None`")  # noqa: E501

        self._writable = writable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SlotDef):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SlotDef):
            return True

        return self.to_dict() != other.to_dict()
