# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class SummaryCampaignStoreBudget(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'action': 'str',
        'period': 'str',
        'store_count': 'int'
    }

    attribute_map = {
        'action': 'action',
        'period': 'period',
        'store_count': 'storeCount'
    }

    def __init__(self, action=None, period=None, store_count=None, local_vars_configuration=None):  # noqa: E501
        """SummaryCampaignStoreBudget - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._action = None
        self._period = None
        self._store_count = None
        self.discriminator = None

        self.action = action
        if period is not None:
            self.period = period
        self.store_count = store_count

    @property
    def action(self):
        """Gets the action of this SummaryCampaignStoreBudget.  # noqa: E501


        :return: The action of this SummaryCampaignStoreBudget.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this SummaryCampaignStoreBudget.


        :param action: The action of this SummaryCampaignStoreBudget.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and action is None:  # noqa: E501
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501
        allowed_values = ["redeemCoupon", "redeemReferral", "setDiscount", "setDiscountEffect", "createCoupon", "createReferral", "createLoyaltyPoints", "redeemLoyaltyPoints", "customEffect", "createLoyaltyPointsEffect", "redeemLoyaltyPointsEffect", "callApi", "awardGiveaway", "addFreeItemEffect", "reserveCoupon"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and action not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def period(self):
        """Gets the period of this SummaryCampaignStoreBudget.  # noqa: E501


        :return: The period of this SummaryCampaignStoreBudget.  # noqa: E501
        :rtype: str
        """
        return self._period

    @period.setter
    def period(self, period):
        """Sets the period of this SummaryCampaignStoreBudget.


        :param period: The period of this SummaryCampaignStoreBudget.  # noqa: E501
        :type: str
        """
        allowed_values = ["overall", "daily", "weekly", "monthly", "yearly"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and period not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `period` ({0}), must be one of {1}"  # noqa: E501
                .format(period, allowed_values)
            )

        self._period = period

    @property
    def store_count(self):
        """Gets the store_count of this SummaryCampaignStoreBudget.  # noqa: E501


        :return: The store_count of this SummaryCampaignStoreBudget.  # noqa: E501
        :rtype: int
        """
        return self._store_count

    @store_count.setter
    def store_count(self, store_count):
        """Sets the store_count of this SummaryCampaignStoreBudget.


        :param store_count: The store_count of this SummaryCampaignStoreBudget.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and store_count is None:  # noqa: E501
            raise ValueError("Invalid value for `store_count`, must not be `None`")  # noqa: E501

        self._store_count = store_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SummaryCampaignStoreBudget):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SummaryCampaignStoreBudget):
            return True

        return self.to_dict() != other.to_dict()
