# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class TalangAttributeVisibility(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'invisible': 'list[str]',
        'visible': 'list[str]'
    }

    attribute_map = {
        'invisible': 'invisible',
        'visible': 'visible'
    }

    def __init__(self, invisible=None, visible=None, local_vars_configuration=None):  # noqa: E501
        """TalangAttributeVisibility - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._invisible = None
        self._visible = None
        self.discriminator = None

        if invisible is not None:
            self.invisible = invisible
        if visible is not None:
            self.visible = visible

    @property
    def invisible(self):
        """Gets the invisible of this TalangAttributeVisibility.  # noqa: E501

        List of attribute names to hide in the UI.  # noqa: E501

        :return: The invisible of this TalangAttributeVisibility.  # noqa: E501
        :rtype: list[str]
        """
        return self._invisible

    @invisible.setter
    def invisible(self, invisible):
        """Sets the invisible of this TalangAttributeVisibility.

        List of attribute names to hide in the UI.  # noqa: E501

        :param invisible: The invisible of this TalangAttributeVisibility.  # noqa: E501
        :type: list[str]
        """

        self._invisible = invisible

    @property
    def visible(self):
        """Gets the visible of this TalangAttributeVisibility.  # noqa: E501

        List of attribute names to show in the UI.  # noqa: E501

        :return: The visible of this TalangAttributeVisibility.  # noqa: E501
        :rtype: list[str]
        """
        return self._visible

    @visible.setter
    def visible(self, visible):
        """Sets the visible of this TalangAttributeVisibility.

        List of attribute names to show in the UI.  # noqa: E501

        :param visible: The visible of this TalangAttributeVisibility.  # noqa: E501
        :type: list[str]
        """

        self._visible = visible

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TalangAttributeVisibility):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TalangAttributeVisibility):
            return True

        return self.to_dict() != other.to_dict()
