# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class TwoFAConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'enabled': 'bool',
        'require_every_sign_in': 'bool'
    }

    attribute_map = {
        'enabled': 'enabled',
        'require_every_sign_in': 'requireEverySignIn'
    }

    def __init__(self, enabled=None, require_every_sign_in=None, local_vars_configuration=None):  # noqa: E501
        """TwoFAConfig - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._enabled = None
        self._require_every_sign_in = None
        self.discriminator = None

        self.enabled = enabled
        if require_every_sign_in is not None:
            self.require_every_sign_in = require_every_sign_in

    @property
    def enabled(self):
        """Gets the enabled of this TwoFAConfig.  # noqa: E501

        An indication of whether two-factor authentication is enabled for the account.  # noqa: E501

        :return: The enabled of this TwoFAConfig.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this TwoFAConfig.

        An indication of whether two-factor authentication is enabled for the account.  # noqa: E501

        :param enabled: The enabled of this TwoFAConfig.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and enabled is None:  # noqa: E501
            raise ValueError("Invalid value for `enabled`, must not be `None`")  # noqa: E501

        self._enabled = enabled

    @property
    def require_every_sign_in(self):
        """Gets the require_every_sign_in of this TwoFAConfig.  # noqa: E501

        Can be `true` or `false`. - `true`: Two-factor authentication is required each time a user signs in to their Talon.One account. - `false`: Two-factor authentication is only required when a user signs in to their Talon.One account on a new device, and every 30 days after that.   # noqa: E501

        :return: The require_every_sign_in of this TwoFAConfig.  # noqa: E501
        :rtype: bool
        """
        return self._require_every_sign_in

    @require_every_sign_in.setter
    def require_every_sign_in(self, require_every_sign_in):
        """Sets the require_every_sign_in of this TwoFAConfig.

        Can be `true` or `false`. - `true`: Two-factor authentication is required each time a user signs in to their Talon.One account. - `false`: Two-factor authentication is only required when a user signs in to their Talon.One account on a new device, and every 30 days after that.   # noqa: E501

        :param require_every_sign_in: The require_every_sign_in of this TwoFAConfig.  # noqa: E501
        :type: bool
        """

        self._require_every_sign_in = require_every_sign_in

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TwoFAConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TwoFAConfig):
            return True

        return self.to_dict() != other.to_dict()
