# coding: utf-8

"""
    Talon.One API

    Use the Talon.One API to integrate with your application and to manage applications and campaigns:  - Use the operations in the [Integration API section](#integration-api) are used to integrate with our platform - Use the operation in the [Management API section](#management-api) to manage applications and campaigns.  ## Determining the base URL of the endpoints  The API is available at the same hostname as your Campaign Manager deployment. For example, if you access the Campaign Manager at `https://yourbaseurl.talon.one/`, the URL for the [updateCustomerSessionV2](https://docs.talon.one/integration-api#operation/updateCustomerSessionV2) endpoint is `https://yourbaseurl.talon.one/v2/customer_sessions/{Id}`   # noqa: E501

    The version of the OpenAPI document: 
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from talon_one.configuration import Configuration


class UpdateApplicationCIF(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'description': 'str',
        'active_expression_id': 'int',
        'modified_by': 'int',
        'modified': 'datetime'
    }

    attribute_map = {
        'description': 'description',
        'active_expression_id': 'activeExpressionId',
        'modified_by': 'modifiedBy',
        'modified': 'modified'
    }

    def __init__(self, description=None, active_expression_id=None, modified_by=None, modified=None, local_vars_configuration=None):  # noqa: E501
        """UpdateApplicationCIF - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._description = None
        self._active_expression_id = None
        self._modified_by = None
        self._modified = None
        self.discriminator = None

        if description is not None:
            self.description = description
        if active_expression_id is not None:
            self.active_expression_id = active_expression_id
        if modified_by is not None:
            self.modified_by = modified_by
        if modified is not None:
            self.modified = modified

    @property
    def description(self):
        """Gets the description of this UpdateApplicationCIF.  # noqa: E501

        A short description of the Application cart item filter.  # noqa: E501

        :return: The description of this UpdateApplicationCIF.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateApplicationCIF.

        A short description of the Application cart item filter.  # noqa: E501

        :param description: The description of this UpdateApplicationCIF.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def active_expression_id(self):
        """Gets the active_expression_id of this UpdateApplicationCIF.  # noqa: E501

        The ID of the expression that the Application cart item filter uses.  # noqa: E501

        :return: The active_expression_id of this UpdateApplicationCIF.  # noqa: E501
        :rtype: int
        """
        return self._active_expression_id

    @active_expression_id.setter
    def active_expression_id(self, active_expression_id):
        """Sets the active_expression_id of this UpdateApplicationCIF.

        The ID of the expression that the Application cart item filter uses.  # noqa: E501

        :param active_expression_id: The active_expression_id of this UpdateApplicationCIF.  # noqa: E501
        :type: int
        """

        self._active_expression_id = active_expression_id

    @property
    def modified_by(self):
        """Gets the modified_by of this UpdateApplicationCIF.  # noqa: E501

        The ID of the user who last updated the Application cart item filter.  # noqa: E501

        :return: The modified_by of this UpdateApplicationCIF.  # noqa: E501
        :rtype: int
        """
        return self._modified_by

    @modified_by.setter
    def modified_by(self, modified_by):
        """Sets the modified_by of this UpdateApplicationCIF.

        The ID of the user who last updated the Application cart item filter.  # noqa: E501

        :param modified_by: The modified_by of this UpdateApplicationCIF.  # noqa: E501
        :type: int
        """

        self._modified_by = modified_by

    @property
    def modified(self):
        """Gets the modified of this UpdateApplicationCIF.  # noqa: E501

        Timestamp of the most recent update to the Application cart item filter.  # noqa: E501

        :return: The modified of this UpdateApplicationCIF.  # noqa: E501
        :rtype: datetime
        """
        return self._modified

    @modified.setter
    def modified(self, modified):
        """Sets the modified of this UpdateApplicationCIF.

        Timestamp of the most recent update to the Application cart item filter.  # noqa: E501

        :param modified: The modified of this UpdateApplicationCIF.  # noqa: E501
        :type: datetime
        """

        self._modified = modified

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateApplicationCIF):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateApplicationCIF):
            return True

        return self.to_dict() != other.to_dict()
